Package: DEGraph
Title: Two-sample tests on a graph
Version: 1.64.0
Date: 2012-04-27
Author: Laurent Jacob, Pierre Neuvial and Sandrine Dudoit
Maintainer: Laurent Jacob <laurent.jacob@gmail.com>
Description: DEGraph implements recent hypothesis testing methods which
        directly assess whether a particular gene network is
        differentially expressed between two conditions. This is to be
        contrasted with the more classical two-step approaches which
        first test individual genes, then test gene sets for enrichment
        in differentially expressed genes. These recent methods take
        into account the topology of the network to yield more powerful
        detection procedures. DEGraph provides methods to easily test
        all KEGG pathways for differential expression on any gene
        expression data set and tools to visualize the results.
License: GPL-3
LazyLoad: yes
Imports: graph, KEGGgraph, lattice, mvtnorm, R.methodsS3, RBGL,
        Rgraphviz, rrcov, NCIgraph
Suggests: corpcor, fields, graph, KEGGgraph, lattice, marray, RBGL,
        rrcov, Rgraphviz, NCIgraph
Depends: R (>= 2.10.0), R.utils
biocViews: Microarray, DifferentialExpression, GraphAndNetwork,
        Network, NetworkEnrichment, DecisionTree
git_url: https://git.bioconductor.org/packages/DEGraph
git_branch: RELEASE_3_23
git_last_commit: e996aea
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:38:56 UTC; biocbuild

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Test all (locally stored) pathways from KEGG on Loi's data
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

library('R.utils')
library('xtable')

verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

## force <- TRUE

path <- system.file("downloadScripts", package="DEGraph")
sourceDirectory(path)

path <- system.file("demoScripts", package="DEGraph")
sourceDirectory(path)

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## get all NCI pathways
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## library('NCIgraph')
path <- system.file("downloadScripts", package="NCIgraph")
sourceDirectory(path)
load(file.path('rawNCINetworks','NCI-cyList.RData'))

grList <- getNCIPathways(cyList=NCI.cyList, verbose=verbose)$pList

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## get all KEGG pathways
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## grList <- getKEGGPathways(organism="hsa", metaTag="non-metabolic", verbose=verbose)
## grList <- getKEGGPathways(organism="hsa", metaTag="non-metabolic", patt="04060", verbose=verbose)

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## test all KEGG pathways
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## Individual t-test p-values
res <- apply(exprData, 1, FUN=function(x) {
 tt <- t.test(x[classData==0], x[classData==1])  ## resistant (0) vs sensitive (1)
 c(statistic=tt$statistic[[1]], p.value=tt$p.value)
})
ttpv <- res["p.value", ]
tts <- res["statistic", ]

if(!is.NCIgraph(grList[[1]]))
  {
    names(ttpv) <- translateGeneID2KEGGID(names(ttpv))
    names(tts) <- translateGeneID2KEGGID(names(tts))
  }

prop <- 0.2 ## proportion of the spectrum to be retained for T2-Fourier 

## Multivariate tests
resList <- NULL
## for (ii in 1:5) {
for (ii in seq(along=grList)) {
  verbose && cat(verbose, ii)
  gr <- grList[[ii]]
  if(min(length(nodes(gr)),length(gr@edgeData@data))>0) {
    res <- testOneGraph(gr, exprData, classData, verbose=verbose, prop=prop)
  } else {
    res <- NULL
  }
  if(!is.null(res)) {
    res <- lapply(res, FUN=function(x) {
      if(!is.null(x)) {
          if(is.NCIgraph(x$graph)) {
            geneIDs <- translateNCI2GeneID(x$graph)
          } else {
            geneIDs <- translateKEGGID2GeneID(nodes(x$graph))
          }
          ht <- hyper.test(ttpv, geneIDs, thr=0.001)
          x$p.value <- c(x$p.value, ht$p.value)
          names(x$p.value)[length(names(x$p.value))] <- "Hypergeometric test"
          return(x)
        } else {
          return(NULL)
        }
    })
  }
  resList <- c(resList, list(res))
}
resNames <- names(grList)

if(is.NCIgraph(grList[[1]])) {
  pLabels <- names(grList)
} else {
  pLabels <- sapply(grList, attr, "label")
}

## get rid of NULL results (no connected component of size > 1)
isNULL <- sapply(resList, is.null)
if (sum(isNULL)) {
  grList[isNULL]
  resList <- resList[!isNULL]
  resNames <- names(grList)[!isNULL]
  pLabels <- pLabels[!isNULL]
}

resL <- sapply(resList, length)
graphNames <- rep(resNames, times=resL)
pathwayNames <- rep(pLabels, times=resL)
verbose && str(verbose, graphNames)
verbose && print(verbose, table(graphNames))

graphList <- NULL
for (res in resList) {
  grl <- lapply(res, FUN=function(x) {
    x$graph
  })
  graphList <- c(graphList, as.list(grl))
}

ndims <- NULL
for (res in resList) {
  ndim <- sapply(res, FUN=function(x) {
    x$k
  })
  ndims <- c(ndims, ndim)
}

## Compare results
pKEGG <- NULL
for (res in resList) {
  pp <- sapply(res, FUN=function(x) {
    x$p.value
  })
  if(length(pp))
    pKEGG <- cbind(pKEGG, pp)
}
colnames(pKEGG) <- graphNames
rn <- rownames(pKEGG)
rownames(pKEGG)[grep("Fourier", rn)] <- paste("T2 (", round(100*prop), "% Fourier components)", sep="")

pH <- pKEGG[1,]
pF <- pKEGG[2,]
pHG <- pKEGG[3,]

## Before multiple testing correction
plot(sort(pKEGG[1, ]), t='l', xlab="Rank", ylab="p-value")
lines(sort(pKEGG[2, ]), col=2)
lines(sort(pKEGG[3, ]), col=3)
legend("topleft", rownames(pKEGG), lty=1, col=1:3) 
     
## multiple testing correction(s)
BHpKEGG <- t(apply(pKEGG, 1, p.adjust, method="BH"))
BYpKEGG <- t(apply(pKEGG, 1, p.adjust, method="BY"))  ## more conservative, but OK w. any dependency

thr <- c(0.05, 0.1, 0.2)[2]

## number of pathways passing the threshold
apply(BHpKEGG, 1, FUN=function(p) sum(p<thr))
apply(BYpKEGG, 1, FUN=function(p) sum(p<thr))

wHF <- which((pH<thr) & (pF>thr))
wFH <- which((pF<thr) & (pH>thr))
wFHG <- which((pF<thr) & (pHG>thr))
wHGF <- which((pHG<thr) & (pF>thr))
wHHG <- which((pH<thr) & (pHG>thr))
wHGH <- which((pHG<thr) & (pH>thr))

dev.new()
pKEGG[is.na(pKEGG)] <- 1
c3 <- t(pKEGG < 0.01)
a <- vennCounts(c3)
vennDiagram(a,names=c("Hotelling","Fourier","Hypergeometric"))
title(sprintf("Number of significant genes\n with the three uncorrected tests at level %3f",0.01))

dev.new()
BHpKEGG[is.na(BHpKEGG)] <- 1
c3 <- t(BHpKEGG < thr)
a <- vennCounts(c3)
vennDiagram(a,names=c("Hotelling","Fourier","Hypergeometric"))
title(sprintf("Number of significant genes\n with the three BH-corrected tests at level %3f",thr))

dev.new()
BYpKEGG[is.na(BYpKEGG)] <- 1
c3 <- t(BYpKEGG < thr)
a <- vennCounts(c3)
vennDiagram(a,names=c("Hotelling","Fourier","Hypergeometric"))
title(sprintf("Number of significant genes\n with the three BY-corrected tests at level %3f",thr))

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Visualization of a pathway
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

##pathwayNames[graphNames[order(pHG)[[1]]]]

oo <- order(pF/pH)[1:25]

gIdx <- oo[1]

gr <- graphList[[gIdx]]
pathwayNames[graphNames[gIdx]]
if (require(marray)) {
  pal <- maPalette(low="red", high="green", mid="black", k=100)
} else {
  pal <- heat.colors(100)
}
shift <- tts # Plot t-statistics
##shift <- -getMeanShift(exprData, classData) # Plot mean shifts

## dn <- getDisplayName(gr, shortLabel=TRUE)

if(is.NCIgraph(gr)) {
  mm <- match(translateNCI2GeneID(gr), rownames(annData))
  nodes(gr) <- translateNCI2GeneID(gr)
} else {
  mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
}
dn <- annData[mm, "NCBI.gene.symbol"]

##pdf("Loi2008-leukocyte.pdf",width=10,height=10)
res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.7, verbose=verbose)
##devDone()
title(paste(pathwayNames[graphNames[gIdx]],"pF=",as.character(signif(pF[gIdx],4)),"pH=",as.character(signif(pH[gIdx],4))))

## mm <- match(translateKEGGID2GeneID(nodes(gr)), names(shift))
## plotValuedGraph(gr, values=shift[mm], qMax=0.95, colorPalette=pal, height=1, lwd=1, verbose=verbose)

## Example: look at the pathways which are significant with Fourier
## after correction but would have large p-values without the Fourier
## step.

fSignif <- which(BHpKEGG[2,]<0.05)
fSignif <- fSignif[order(BHpKEGG[1,fSignif],decreasing=TRUE)]
##fSignif <- fSignif[order(BHpKEGG[2,fSignif],decreasing=FALSE)] # Order by increasing pF


## Plot all graphs
##dev.new()
##printFileName <- "Tech-MI-smoothGraphs-loi-dec"
printFileName <- "Loi-NCI"
printStarted <- FALSE
pdf(paste(printFileName,".pdf",sep=""))
for (gIdx in fSignif) {
  ## Get graph
  gr <- graphList[[gIdx]]

  if(is.NCIgraph(gr)) {
    mm <- match(translateNCI2GeneID(gr), rownames(annData))
    nodes(gr) <- translateNCI2GeneID(gr)
  } else {
    mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
  }
  dn <- annData[mm, "NCBI.gene.symbol"]

  ## Try to plot
  tt <- try(res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.3, verbose=verbose))
  ## Add legend
  if (class(tt)!="try-error") {
    stext(side=3, pos=0, pathwayNames[gIdx])
    ps <- signif(pKEGG[, gIdx],2)
    txt1 <- paste("p(T2)=", ps[1], sep="")
    txt2 <- paste("p(T2F[", ndims[gIdx], "])=", ps[2], sep="")
    txt <- paste(txt1, txt2, sep="\n")
    stext(side=3, pos=1, txt)
    image.plot(legend.only=TRUE, zlim=range(res$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3)
    ## Now print gene table in a tex file
    cIdx <- match(nodes(gr),names(shift)) #which(names(shift)%in% nodes(gr))
    gTable <- cbind(dn,signif(shift[cIdx],2),signif(ttpv[cIdx],2))
    colnames(gTable) <- c("Gene symbol","t-stat","p-value")
    xt <- xtable(gTable,caption=sprintf("%s, p(Hotelling)=%g, p(netHotelling)=%g",pathwayNames[gIdx], ps[1], ps[2]))
    print(xt,file=paste(printFileName,"-Tables.tex",sep=""),tabular.environment='longtable',floating=FALSE, append=printStarted)
    printStarted <- TRUE
  } else {
    warning("check gIdx=", gIdx)
  }
}
devDone()

## Save results
ts <- format(Sys.time(), "%Y-%m-%d,%X")
filename <- sprintf("pKEGG,signed,normalized,%s.rda", ts)
save(resList, pKEGG, graphList, pathwayNames, ndims, file=filename)

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction testOneConnectedComponent
##
## @title "Applies a series of two-sample tests to a connected graph using various statistics"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{graph}{A \code{\link[=graph-class]{graph}} object.}
##   \item{data}{A '@numeric @matrix (size: number 'p' of genes x number 'n' of samples) of gene expression.}
##   \item{classes}{A @character @vector (length: 'n') of class assignments.}
##   \item{...}{Further arguments to be passed to @see "laplacianFromA".}
##   \item{prop}{A @numeric value, percentage of components retained for Fourier and PCA.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##  A structured @list containing the p-values of the tests, the 
##  \code{\link[=graph-class]{graph}} object of the connected component and the number 
##  of retained Fourier dimensions.
## }
##
## @author
##
## \details{
##   This function performs the test, assuming that all genes
##   in the graph are represented in the expression data set,
##   in order not to have to modify the graph topology.
##
##   Interaction signs are used if available in the graph
##   ('getSignedGraph' is not called here, in order not to
##   have to modify the graph topology.).
##
##   The graph given as input has to have only one
##   connex component.  It can be retrieved from the output of
##   @see "getConnectedComponentList".
## }
##
## \seealso{
##   @see "testOneGraph"
##   @see "getConnectedComponentList"
## }
##
## @examples "../incl/graph.T2.test.Rex"
##
##*/########################################################################

testOneConnectedComponent <- function(graph, data, classes, ..., prop=0.2, verbose=FALSE) {
  ## - - - - - - - - - - - - - - - - - - -
  ## Validate arguments
  ## - - - - - - - - - - - - - - - - - - -
  ## Argument 'classes'
  classes <- Arguments$getNumerics(classes)
  ll <- length(unique(classes))
  if (ll != 2) {
    throw("Number of classes should be 2, not ", ll)
  }
  rm(ll)

  ## Argument 'data'
  cls <- class(data)[1]
  if (cls != "matrix") {
    throw("Arguments 'data' should be a 'matrix', not a ", cls)
  }
  n <- ncol(data)
  nc <- length(classes)
  if (n != nc) {
    throw("Number of samples in 'data' (", n, ") should match number of samples in 'classes' (", nc, ")")
  }
  rm(nc)

  ## Argument 'graph'
  if (!validGraph(graph)) {
    throw("Argument 'graph' is not a valid graph object")
  }
  ## Check that there is only one connex component
  cc <- connectedComp(graph)
  if (length(cc)>1) {
    throw("More than one connex component in graph")
  }
  rm(cc)

  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  } 

  ## check consistency between gene and node names
  verbose && enter(verbose, "Keeping genes in the graph *and* the expression data set")
  dataGN <- rownames(data)
  graphGN <- nodes(graph)
  mm <- match(graphGN, dataGN)
  ww <- which(is.na(mm))
  ll <- length(ww)
  if (ll) {
    throw(ll, " genes of the graph were not found in the expression data set: ")
  }
  ## sorting (and subsetting if necessary)
  data <- data[mm, ]

  ## sanity check (ordering should be the same now)
  dataGN <- rownames(data)
  stopifnot(all.equal(dataGN, graphGN))
  rm(graphGN)
  rm(dataGN)
  verbose && exit(verbose)

  p <- numNodes(graph)
  geneNames <- rownames(data)

  cls <- sort(unique(classes))
  X1 <- t(data[, classes==cls[1]])
  X2 <- t(data[, classes==cls[2]])

  ## get sign information (if any) and infer from its presence the type of graph
  #signMat <- attr(graph, 'signMat')
  signMat <- graph@graphData$signMat
  if (is.null(signMat)) {
    verbose && cat(verbose, "Unsigned graph")
    ## use adjacency matrix of the corresponding undirected graph
    ##ugraph <- ugraph(graph)
    ##graphAM <- as(ugraph, "graphAM")
    ##adjMat <- graphAM@adjMat
    adjMat <- as(graph,"graphAM")@adjMat
    ## sanity check: symmetry
    ##stopifnot(sum(sum(t(adjMat)!=adjMat))==0)
    mat <- adjMat
  } else {
    verbose && cat(verbose, "Signed graph")
    mat <- signMat
  }

  ##print(mat)
  
  ## Argument 'prop'
  if (is.null(prop)) {
    prop <- c(0.05, 0.1, 0.2, 0.4)
    ndim <- unique(c(1:5, ceiling(p*prop)))
    ndim <- sort(ndim[ndim<=p])
  } else {
    prop <- Arguments$getNumerics(prop, range=c(0, 1))
    ndim <- unique(ceiling(p*prop))
  }

  dg <- rowSums(abs(mat))
  verbose && cat(verbose, "Degrees")
  verbose && str(verbose, dg)
  ## TODO: take multiplicity of eigen value into account using parameter 'k'
  lfA <- laplacianFromA(mat, ..., ltype="meanInfluence", k=1)
  U <- lfA$U

  res <- NULL
  resNames <- NULL

  ## T2 in original space
  verbose && enter(verbose, "Testing")
  verbose && cat(verbose, "Raw T2 (Hotelling)")
  T2H <- try(T2.test(X1, X2))
  if (class(T2H)=="try-error") {
    pH <- NA
  } else {
    pH <- T2H$p.value
    verbose & str(verbose, pH)
  }
  res <- c(res, pH)
  resNames <- c(resNames, "T2")

  ## T2 in Fourier space
  verbose && cat(verbose, "T2 on Fourier components")
  pU <- rep(NA, length=length(ndim))
  names(pU) <- ndim
  for (kk in seq(along=ndim)) {
    kR <- ndim[kk]
    T2U <- graph.T2.test(X1, X2, G=NULL, lfA=lfA, k=kR)
    ##T2U <- T2.test(X1%*%U[, 1:kR], X2%*%U[, 1:kR])
    pU[kk] <- T2U$p.value
  }
  verbose & str(verbose, pU)
  res <- c(res, pU)
  resNames <- c(resNames, paste("T2 (", ndim, " Fourier components)", sep=""))

  ## T2 with PCA, other test statistics
  if (FALSE) {
  verbose && cat(verbose, "T2 on PCA components")
  edX <- svd(rbind(X1, X2))
  E <- edX$v
  pPCA <- rep(NA, length=length(ndim))
  names(pPCA) <- ndim
  for (kk in seq(along=ndim)) {
    kR <- ndim[kk]
    T2PCA <- T2.test(X1%*%E[, 1:kR], X2%*%E[, 1:kR])
    pPCA[kk] <- T2PCA$p.value
  }
  res <- c(res, pPCA)
  resNames <- c(resames, paste("T2 (", ndim, " PCA components)", sep=""))

  verbose & str(verbose, pPCA)

  verbose && cat(verbose, "Adaptive Neyman (Fan)")
  T2AN <- AN.test(X1%*%U, X2%*%U, p)
  pAN <- T2AN$p.value
  verbose & str(verbose, pAN)

  res <- c(res, pAN)
  resNames <- c(resames, "Adaptive Neyman")
  } ## if (FALSE)

  verbose && exit(verbose)

  names(res) <- resNames
  ret <- list(p.value=res, graph=graph, k=ndim)

  ret
}

############################################################################
## HISTORY:
## 2010-10-08
## o Now validating argument 'verbose'.
## 2010-10-01
## o Now manipulates A instead of t(A) (transposition made within
##   laplacianFromA).
## 2010-08-05
## o CLEAN-UP: Now uses 'laplacianFromA'.
## 2010-07-15
## o ROBUSTIFICATION: Now use 'cls <- sort(unique(classes))' to make 'cls'
##   independent of the input order of the label vector.
## 2010-05
## o Created.
############################################################################

### R code from vignette source 'DEGraph.Rnw'

###################################################
### code chunk number 1: lib
###################################################
library(DEGraph)


###################################################
### code chunk number 2: morelib
###################################################
library("R.utils")
##library(graph)
##library(rrcov) ## for 'T2.test'
library(corpcor)
library(KEGGgraph)
library(Rgraphviz)
##library(RBGL)
library(fields) # For image.plot called in plotValuedGraph
library(lattice)
library(marray)
verbose <- TRUE


###################################################
### code chunk number 3: data
###################################################
data("Loi2008_DEGraphVignette", package="DEGraph")
classData <- classLoi2008
exprData <- exprLoi2008
annData <- annLoi2008
grList <- grListKEGG


###################################################
### code chunk number 4: ttests
###################################################
## Individual t-test p-values
X1 <- t(exprData[, classData==0])
X2 <- t(exprData[, classData==1])
ttpv <- c()
tts <- c()
for(i in 1:ncol(X1)) {
  tt <- t.test(X1[,i],X2[,i])
  ttpv[i]=unlist(tt$p.value)
  tts[i]=unlist(tt$statistic)
}
names(ttpv) <- names(tts) <- rownames(exprData)


###################################################
### code chunk number 5: mvtests
###################################################
prop <- 0.2
## Multivariate tests
resList <- NULL
for (ii in seq(along=grList)) {
  gr <- grList[[ii]]
  res <- testOneGraph(gr, exprData, classData, verbose=verbose, prop=prop)
  resList <- c(resList, list(res))
}
resNames <- names(grList)
pLabels <- sapply(grList, attr, "label")

## get rid of NULL results (no connected component of size > 1)
isNULL <- sapply(resList, is.null)
if (sum(isNULL)) {
  grList[isNULL]
  resList <- resList[!isNULL]
  resNames <- names(grList)[!isNULL]
  pLabels <- pLabels[!isNULL]
}

resL <- sapply(resList, length)
graphNames <- rep(resNames, times=resL)
pathwayNames <- rep(pLabels, times=resL)

graphList <- NULL
for (res in resList) {
  grl <- lapply(res, FUN=function(x) {
    x$graph
  })
  graphList <- c(graphList, as.list(grl))
}

ndims <- NULL
for (res in resList) {
  ndim <- sapply(res, FUN=function(x) {
    x$k
  })
  ndims <- c(ndims, ndim)
}

pKEGG <- NULL
for (res in resList) {
  pp <- sapply(res, FUN=function(x) {
    x$p.value
  })
  pKEGG <- cbind(pKEGG, pp)
}
colnames(pKEGG) <- graphNames
rn <- rownames(pKEGG)
rownames(pKEGG)[grep("Fourier", rn)] <- paste("T2 (", round(100*prop), "% Fourier components)", sep="")

if (exists("maPalette", mode="function")) {
  pal <- maPalette(low="red", high="green", mid="black", k=100)
} else {
  pal <- heat.colors(100)
}
shift <- tts # Plot t-statistics
names(shift) <- translateGeneID2KEGGID(names(tts))
fSignif <- which(pKEGG[2,] < 0.05)
fSignif <- fSignif[order(pKEGG[2,fSignif])]


###################################################
### code chunk number 6: path1
###################################################
gIdx <- fSignif[1]
gr <- graphList[[gIdx]]
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.3, verbose=verbose)
stext(side=3, pos=0, pathwayNames[gIdx])
ps <- signif(pKEGG[, gIdx],2)
txt1 <- paste("p(T2)=", ps[1], sep="")
txt2 <- paste("p(T2F[", ndims[gIdx], "])=", ps[2], sep="")
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
image.plot(legend.only=TRUE, zlim=range(res$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3) 


###################################################
### code chunk number 7: path2
###################################################
gIdx <- fSignif[5]
gr <- graphList[[gIdx]]
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.3, verbose=verbose)
stext(side=3, pos=0, pathwayNames[gIdx])
ps <- signif(pKEGG[, gIdx],2)
txt1 <- paste("p(T2)=", ps[1], sep="")
txt2 <- paste("p(T2F[", ndims[gIdx], "])=", ps[2], sep="")
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
image.plot(legend.only=TRUE, zlim=range(res$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3) 


###################################################
### code chunk number 8: showpath1
###################################################
gIdx <- fSignif[1]
gr <- graphList[[gIdx]]
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.3, verbose=verbose)
stext(side=3, pos=0, pathwayNames[gIdx])
ps <- signif(pKEGG[, gIdx],2)
txt1 <- paste("p(T2)=", ps[1], sep="")
txt2 <- paste("p(T2F[", ndims[gIdx], "])=", ps[2], sep="")
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
image.plot(legend.only=TRUE, zlim=range(res$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3) 


###################################################
### code chunk number 9: showpath2
###################################################
gIdx <- fSignif[5]
gr <- graphList[[gIdx]]
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.3, verbose=verbose)
stext(side=3, pos=0, pathwayNames[gIdx])
ps <- signif(pKEGG[, gIdx],2)
txt1 <- paste("p(T2)=", ps[1], sep="")
txt2 <- paste("p(T2F[", ndims[gIdx], "])=", ps[2], sep="")
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
image.plot(legend.only=TRUE, zlim=range(res$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3) 

library("R.utils")
library("DEGraph")
pathname <- system.file("demoScripts", "001.setup.R", package="DEGraph")
source(pathname)

## Parameters

NP <- 500
NN <- 500
k <- 3  ## true number of Fourier components
kRs <- 2:4  ## number of Fourier components retained
n1 <- 20
n2 <- 20
# shift <- 0.5 ## Amplitude of the shift
ncp <- 0.5

print("[toy] Building data")

## Get graph
nnodes <- 20
nedges <- 20
G <- randomWAMGraph(nnodes=nnodes,nedges=nedges)
A <- G@adjMat

#A <- rbind(c(0,1,0,0,1,0),
#           c(1,0,1,0,1,0),
#           c(0,1,0,1,0,0),
#           c(0,0,1,0,1,1),
#           c(1,1,0,1,0,0),
#           c(0,0,0,1,0,0))

p <- nrow(A)
##D <- diag(rowSums(abs(A)))
##L <- D - A # Unormalized version
iDs <- diag(1/sqrt(rowSums(abs(A))))
L <- diag(rep(1,p)) - (iDs %*% A %*% iDs)
##edL <- eigen(L,symmetric=TRUE)
##U <- fliplr(edL$vectors)
##l <- fliplr(edL$values)

lfA <- laplacianFromA(A,ltype="unnormalized")
U <- lfA$U
l <- lfA$l

sigma <- diag(p)/sqrt(p)
sigma[1:k,1:k] <- sigma[1:k,1:k] + 0.5/sqrt(p)
diag(sigma)[1:k] <- diag(sigma)[1:k] - 0.6/sqrt(p)

## Build and test examples

scores = rep(NA,NN+NP)
uscores = matrix(NA, NN+NP, length(kRs))
pcascores = rep(NA,NN+NP)
anscores = rep(NA,NN+NP)
ant = rep(NA,NN+NP)
ank = rep(NA,NN+NP)
cqscores = rep(NA,NN+NP)
cqq = rep(NA,NN+NP)
bsscores = rep(NA,NN+NP)
bsz = rep(NA,NN+NP)

print("[toy] Starting tests")

for(ii in 1:(NP+NN))
{
  ##X <- twoSmoothSampleFromGraph(n1,n2,shiftM2=ncp*as(ii<NP,"integer"),sigma,U=U,l=l)
  X <- twoSampleFromGraph(n1,n2,shiftM2=ncp*as(ii<NP,"integer"),sigma,U=U,k=k)
  ## Raw T-square
  t <- T2.test(X$X1,X$X2)
  scores[ii] <- t$p.value
  ## Filtered T-squares
  for (kk in seq(along=kRs)) {
    kR <- kRs[kk]
    tu <- graph.T2.test(X$X1,X$X2,lfA=lfA,k=kR)
    ##tu <- T2.test(X$X1%*%U[,1:kR],X$X2%*%U[,1:kR])
    uscores[ii, kk] <- tu$p.value
  }
  ## PCA T-square
  edX <- svd(rbind(X$X1,X$X2))
  E <- edX$v
  tpca <- T2.test(X$X1%*%E[,1:k],X$X2%*%E[,1:k])
  pcascores[ii] <- tpca$p.value
  ## Adaptive Neyman (Fan)
  tan <- AN.test(X$X1%*%U,X$X2%*%U,p)
  anscores[ii] <- tan$p.value
  ant[ii] <- tan$statistic
  ank[ii] <- tan$kstar
  ## Chen & Qin
  ##tcq <- CQ.Test(X$X1,X$X2)
  ##cqscores[ii] <- tcq$p.value
  ##cqq[ii] <- tcq$q
  ## Chen & Qin
  tbs <- BS.test(X$X1,X$X2)
  bsscores[ii] <- tbs$p.value
  bsz[ii] <- tbs$statistic
}

print("[toy] Tests done")

## ROC


# Empirical
thr = seq(0,1,0.001) # c(0.00001,0.0001,0.001,0.01,0.1)
nT <- length(thr)
tpower = rep(NA, nT)
tlevel = rep(NA, nT)
utpower = matrix(NA, nT, length(kRs))
utlevel = matrix(NA, nT, length(kRs))
pcatpower = rep(NA, nT)
pcatlevel = rep(NA, nT)
anpower = rep(NA, nT)
anlevel = rep(NA, nT)
cqpower = rep(NA, nT)
cqlevel = rep(NA, nT)
bspower = rep(NA, nT)
bslevel = rep(NA, nT)

for(cc in seq(along=thr))
{
  i <- thr[cc]
  tpower[cc] <- mean(scores[1:NP]<i)
  tlevel[cc] <- mean(scores[NP+1:NN]<i)
  for (kk in seq(along=kRs)) {
    utpower[cc, kk] <- mean(uscores[1:NP, kk]<i)
    utlevel[cc, kk] <- mean(uscores[NP+1:NN, kk]<i)
  }
  pcatpower[cc] <- mean(pcascores[1:NP]<i)
  pcatlevel[cc] <- mean(pcascores[NP+1:NN]<i)
  anpower[cc] <- mean(anscores[1:NP]<i)
  anlevel[cc] <- mean(anscores[NP+1:NN]<i)
  cqpower[cc] <- mean(cqscores[1:NP]<i)
  cqlevel[cc] <- mean(cqscores[NP+1:NN]<i)
  bspower[cc] <- mean(bsscores[1:NP]<i)
  bslevel[cc] <- mean(bsscores[NP+1:NN]<i)
}


# Theoretical
kR <- k
#ncp <- (n1*n2/(n1+n2)) * shift^2*sqrt(p)
ncp <- (n1*n2/(n1+n2)) * ncp
df1 <- p
df2 <- n1+n2-p-1
nullquant <- qf(1-thr, df1, df2, 0)
thtpower <- 1-pf(nullquant, p, df2, ncp)

## thutpower <- sapply(kRs, FUN=function(kR) {
##   df1 <- kR
##   df2 <- n1+n2-kR-1
##   unullquant <- qf(1-thr, df1, df2, 0)
##   df1 <- k
##   df2 <- n1+n2-k-1
##   1-pf(unullquant, df1, df2, ncp)
## })

thutpower <- sapply(kRs, FUN=function(kR) {
  if (kR==k) {
    df1 <- k
    df2 <- n1+n2-k-1
    unullquant <- qf(1-thr, df1, df2, 0)
    res <- 1-pf(unullquant, df1, df2, ncp)
  } else if (kR>k) {
    df1 <- kR
    df2 <- n1+n2-kR-1
    unullquant <- qf(1-thr, df1, df2, 0)
    res <- 1-pf(unullquant, df1, df2, ncp)
  } else {
    res <- rep(NA, length(thr))
  }
  res
})

## plot parameters
lim <- c(0,1)

txt <- paste("Graph of size ", nnodes, " Shift in the first ", k, " Fourier components", sep="")

lgd <- paste("T2, k=", kRs, sep="")
lgd <- c("T2", lgd)
lgd <- c(paste("theoretical", lgd), paste("simulated", lgd))
lgd <- c(lgd, paste("simulated", k, "first PC"), "simulated AN")

nn <- length(kRs)+1
cols <- seq(nn+2)
ltys <- c(rep(1:2, each=nn), 3, 3)

## Plot: power vs threshold
if(FALSE){
x11()
plot(thr,tpower,type='s', col=cols[1], xlab="Threshold", ylab="Test power", xlim=lim, ylim=lim, lty=2)
lines(thr,thtpower, col=cols[1])
for (kk in seq(along=kRs)) {
  lines(thr, utpower[, kk], col=cols[1+kk], lty=2, type='s')
  lines(thr,thutpower[, kk], col=cols[1+kk])
}
lines(thr, pcatpower, col=cols[2+kk], lty=3, type='s')
lines(thr, anpower, col=cols[3+kk], lty=3, type='s')
legend("bottomright", lgd, col=cols, lty=ltys, ncol=2)
mtext(txt, side=3, adj=1)
}

if (FALSE) {
## Plot: level vs threshold
x11()
plot(thr,tlevel,type='s', col=cols[1], xlab="Threshold", ylab="Test level", xlim=lim, ylim=lim)
for (kk in seq(along=kRs)) {
  lines(thr, utlevel[, kk], col=cols[1+kk], lty=1, type='s')
}
lines(thr, pcatlevel, col=cols[1+kk]+1, lty=3, type='s')
lines(thr, anlevel, col=cols[1+kk]+2, lty=3, type='s')
lines(thr, bslevel, col=cols[1+kk]+3, lty=3, type='s')
legend("bottomright", lgd[nn+(1:(nn+2))], col=cols, lty=c(ltys[1:nn],3,3))
mtext(txt, side=3, adj=1)
}

if(TRUE){
## Plot: power vs level
x11()
plot(tlevel,tpower,type='s', col=cols[1], xlab="Test level", ylab="Test power", xlim=lim, ylim=lim)
for (kk in seq(along=kRs)) {
  lines(utlevel[, kk], utpower[, kk], col=cols[1+kk], lty=1, type='s')
}
lines(pcatlevel, pcatpower, col=nn+1, lty=3, type='s')
lines(anlevel, anpower, col=nn+2, lty=3, type='s')
##lines(cqlevel, cqpower, col=nn+2, lty=4, type='s')
lines(bslevel, bspower, col=nn+2, lty=4, type='s')
legend("bottomright", lgd[nn+(1:(nn+2))], col=c(cols,nn+2), lty=c(ltys[1:nn],3,3))
mtext(txt, side=3, adj=1)
}

## Plot: theoretical power vs threshold
x11()
plot(thr,thtpower,type='l', col=cols[1], xlab="Threshold", ylab="Theoretical test power", xlim=lim, ylim=lim)
for (kk in seq(along=kRs)) {
  lines(thr,thutpower[, kk], col=cols[1+kk])
}
legend("bottomright", lgd[1:nn], col=cols, lty=1)
mtext(txt, side=3, adj=1)

library(R.utils)
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

rootPath <- "ftp.genome.jp/pub/kegg/xml/kgml"
organism <- "hsa"

localPath <- "networkData"
localPath <- Arguments$getWritablePath(localPath)

if (!exists("force", mode="character")) {
  force <- FALSE
}

for (tag in c("non-metabolic", "metabolic")) {
  path <- file.path(rootPath, tag, "organisms", organism)
  srcPath <- file.path("ftp:/", path, "")
  tgtPath <- file.path(localPath, path)
  tgtPath <- Arguments$getWritablePath(tgtPath)

  verbose && cat(verbose, "Remote directory:")
  verbose && print(verbose, srcPath)

  verbose && enter(verbose, "Writing directory contents to INDEX file")
  tgtPathname <- file.path(tgtPath, "INDEX")
  downloadFile(srcPath, tgtPathname, method="wget", verbose=verbose)
  verbose && exit(verbose)
  
  fl <- readLines(tgtPathname)
  rm(tgtPathname)
  gg <- grep("File", fl)
  dat <- fl[gg]
  pattern <-   ".*<a href=\\\"(.*)\\\">(.*\\.xml).*"
  srcPathnames <- gsub(pattern, "\\1", dat)
  tgtFilenames <- gsub(pattern, "\\2", dat)
  verbose && cat(verbose, "Contents:")
  verbose && str(verbose, tgtFilenames)

  for (kk in seq(along=srcPathnames)) {
    srcPathname <- srcPathnames[kk]
    tgtFilename <- tgtFilenames[kk]
    tgtPathname <- file.path(tgtPath, tgtFilename)

    downloadFile(srcPathname, tgtPathname, skip=!force, overwrite=force, verbose=verbose)
    ## TODO: remove local files that are not present on the remote server?
  }
}

############################################################################
# HISTORY:
# 2010-09-14
# o Created.
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction BS.test
##
## @title "Performs the test of Bai and Saranadasa (1996)"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{X1}{A n1 x p @matrix, observed data for class 1: p variables, n1
##     observations.}
##   \item{X2}{A n2 x p @matrix, observed data for class 2: p variables, n2
##     observations.}
##   \item{na.rm}{A @logical value indicating whether variables with @NA in
##     at least one of the n1 + n2 observations should be discarder before
##     the test is performed.}
## }
##
## \value{
##  A @list with class "htest" containing the following components:
##  \describe{
##    \item{statistic}{A @numeric value, the test statistic.}
##    \item{p.value}{A @numeric value, the corresponding p-value.}
##   }
## }
##
## @author
##
## \seealso{
##   @see "AN.test"
##   @see "graph.T2.test"
##   @see "hyper.test"
## }
##
## @examples "../incl/tests.Rex"
##
##*/########################################################################

BS.test <- function(X1, X2, na.rm=FALSE) {
  if (na.rm) {
    na1 <- apply(X1, 2, FUN=function(x) sum(is.na(x)))
    na2 <- apply(X2, 2, FUN=function(x) sum(is.na(x)))
    idxs <- which((na1==0) & (na2==0))
    X1 <- X1[, idxs]
    X2 <- X2[, idxs]    
  }
  p <- ncol(X1)
  n1 <- nrow(X1)
  n2 <- nrow(X2)
  n <- n1 + n2 - 2
  X1m <- colMeans(X1)
  X2m <- colMeans(X2)
  dm <- X1m - X2m
  
  dm2 <- t(dm) %*% dm
  
  X1c <- X1 - t(matrix(rep(colMeans(X1),n1),p,n1))
  X2c <- X2 - t(matrix(rep(colMeans(X2),n2),p,n2))  
  Sn <- ((t(X1c) %*% X1c) + (t(X2c) %*% X2c))/n
  
  Bn <- sqrt((n^2/((n+2)*(n-1))) * (sum(diag(Sn%*%Sn)) - (1/n)*(sum(diag(Sn)))^2))
  
  z <- ((n1*n2/(n1+n2))*dm2 - sum(diag(Sn)))/(sqrt((2*(n+1))/n)*Bn)
  p <- 1-pnorm(z)
  
  res <- list(statistic=z,  p.value=p)
  class(res) <- "htest"
  res
}

############################################################################
## HISTORY
## 2010-09-23
## o Added an example.
## o Added an option to remove NA:s.
## 2010-09-22
## o Now returns an object of class "htest".
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction getSignedGraph
##
## @title "Given a graph, builds a signed version of the adjacency matrix
##   taking into account the type of interaction (e.g., activation or
##   inhibition)"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{graph}{A \code{\link[=graph-class]{graph}} object.}
##   \item{positiveInteractionLabels}{A @character @vector specifying which
##     interaction labels correspond to positive interactions. Defaults to
##     'c("activation", "expression")'.}
##   \item{negativeInteractionLabels}{A @character @vector specifying which
##     interaction labels correspond to negative interactions. Defaults to
##     'c("inhibition", "repression")'.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##   This function returns a squared matrix whose (i,j) entry is:
##   \describe{
##     \item{0}{if edges i and j are not connected}
##     \item{1}{if edges i and j are connected by a positive interaction}
##     \item{-1}{if edges i and j are connected by a negative interaction.}
##   }
##   By construction, the absolute value of this matrix is the adjacency
##   matrix of the graph. Edges which cannot interpreted as corresponding
##   to a positive or a negative interaction are marked as not connected.
## }
##
## @author
##
## @examples "../incl/getSignedGraph.Rex"
##
##*/########################################################################

## NOTES:
## adjMat cannot be signed in KEGGgraph objects.
## Long-term fix: implement a 'signedGraph' class that allows that
## Short-term fix: add an attribute 'signMat' to the graph object
##   and use it manually afterwards (it is not properly subsetted
##   when removing nodes from the graph for example.  Actually it
##   is even lost)

getSignedGraph <- function(graph, positiveInteractionLabels=c("activation", "expression"), negativeInteractionLabels=c("inhibition", "repression"), verbose=FALSE) {
  ## - - - - - - - - - - - - - - - - - - -
  ## Validate arguments
  ## - - - - - - - - - - - - - - - - - - -
  ## Argument 'graph'
  if (!validGraph(graph)) {
    throw("Argument 'graph' is not a valid graph object")
  }
  if (!isDirected(graph)) {
    throw("Undirected graphs are not supported yet")
  }
  ## Argument 'positiveInteractionLabels'
  posIntLabs <- Arguments$getCharacters(positiveInteractionLabels)

  ## Argument 'negativeInteractionLabels'
  negIntLabs <- Arguments$getCharacters(negativeInteractionLabels)
  
  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  }

  
  ## retrieve edge types (method detects whether or not graph is a NCIgraph)
  ##  if(is.NCIgraph(graph))
  ##    st <- getSubtype.NCIgraph(graph)
  ##  else
  st <- getSubtype(graph) ## FIXME: does not work for undirected graphs
  edgeNames <- names(st)
  intNames <- sapply(st, FUN=function(x) {
    x$subtype@name
  })

  verbose && cat(verbose, "Interactions:")
  verbose && str(verbose, intNames)
  verbose && print(verbose, table(intNames))

  lap <- lapply(posIntLabs, grep, intNames)
  names(lap) <- posIntLabs
  verbose && cat(verbose, "Positive interactions:")
  verbose && str(verbose, lap)
  idxPos <- unlist(lap) 
  
  lan <- lapply(negIntLabs, grep, intNames)
  names(lan) <- negIntLabs
  verbose && cat(verbose, "Negative interactions:")
  verbose && str(verbose, lan)
  idxNeg <- unlist(lan)

  posNames <- edgeNames[idxPos]
  negNames <- edgeNames[idxNeg]

  idx0 <- intersect(idxPos, idxNeg)
  if (length(idx0)) {
      warning("Probable annotation error: positive and negative edges. These edges will be removed")
      idxPos <- idxPos[-match(idx0, idxPos)]
      idxNeg <- idxNeg[-match(idx0, idxNeg)]
  }

  ## Remove other edges
  edgesToRemove <- intNames[-c(idxPos, idxNeg)]
  if (length(edgesToRemove)) {
    verbose && enter(verbose, "Removing unsigned edges from graph")
    verbose && cat(verbose, "Edges to remove:")
    verbose && str(verbose, edgesToRemove)
    verbose && print(verbose, table(edgesToRemove))

    etrNames <- edgeNames[-c(idxPos, idxNeg)]
    ftNames <- sapply(etrNames, FUN=function(edge) {
      unlist(strsplit(edge, "~|\\|"))
    })

    oldGraph <- graph
    graph <- removeEdge(from=ftNames[1, ], ftNames[2, ], graph)
    verbose && print(verbose, graph)

    rm(ftNames)
    verbose && exit(verbose)
  }

  verbose && enter(verbose, "Creating sign matrix")
  ## use adjacency matrix of the corresponding undirected graph
  ## ugraph <- ugraph(graph)
  ## graphAM <- as(ugraph, "graphAM")
  ## sanity check: symmetry
  ## stopifnot(sum(sum(t(adjMat)!=adjMat))==0)
  
  graphAM <- as(graph, "graphAM") # Now use directed version as some energy functions require edge directions
  
  adjMat <- graphAM@adjMat

  signMat <- adjMat

  if (length(negNames)) {
    ## set negative edges to -1
    ftNames <- sapply(negNames, FUN=function(edge) {
      unlist(strsplit(edge, "~|\\|"))
    })
    nodeNames <- colnames(signMat)
    for (ii in seq(length=ncol(ftNames))) {
      ftName <- ftNames[, ii]
      idx <- graph:::getIndices(nodeNames, ftName[1], ftName[2])
      adj <- adjMat[idx$from, idx$to]
      if (adj != 1) { ## Sanity check
        throw("Inconsistent data in adjacency matrix for edge ", paste(ftName, collapse="~"))
      } else {
        signMat[idx$from, idx$to] <- -1
        ##signMat[idx$to, idx$from] <- -1
      }
    }
  }

  if (length(posNames)) {
    ## check that positive edges are 1
    ftNames <- sapply(posNames, FUN=function(edge) {
      unlist(strsplit(edge, "~|\\|"))
    })
    nodeNames <- colnames(signMat)
    for (ii in seq(length=ncol(ftNames))) {
      ftName <- ftNames[, ii]
      idx <- graph:::getIndices(nodeNames, ftName[1], ftName[2])
      adj <- adjMat[idx$from, idx$to]
      if (adj != 1) { ## Sanity check
        throw("Inconsistent data in adjacency matrix for edge", ftName)
      }
    }
  }
  
  
  graph@graphData$signMat <- signMat
  
  #attr(graph, 'signMat') <- signMat
  verbose && exit(verbose)

  graph
}

############################################################################
## HISTORY:
## 2011-03-06
## o Dealing with NCI graphs
## 2010-10-08
## o Now validating argument 'verbose'.
## o Updated arguments.
## 2010-09-17
## o Now returns an directed graph (non symmetric adjacency matrix that
##   takes edge direction into account).
## 2010-07-16
## o Now returns an undirected graph (so that adjacency matrix is symmetric).
##   
## 2010-05
## o Created.
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction plotValuedGraph
##
## @title "Plots a graph with nodes colored according to a quantitative variable"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{graph}{A \code{\link[=graph-class]{graph}} object.}
##   \item{values}{A named @vector of @numeric values according to which the
##     graph nodes should be colored.}
##   \item{nodeLabels}{A @character @vector of the same length and in the
##     same order as 'nodes(graph)': node labels to be displayed.  Defaults
##     to 'nodes(graph)'.}
##   \item{qMax}{A @numeric value, fraction of the data to be truncated in order
##     to avoid outliers.}
##   \item{colorPalette}{A @character vector, the set of colors to be used.}
##   \item{adjustColorRange}{A @logical value.  If @TRUE, the color range is
##     adjusted to the range of values of nodes actually present in the graph.
##     Defaults to @FALSE, i.e. the color range spans range(values) regardless
##     of which nodes are present in the graph.}
##   \item{symmetrizeArrows}{A @logical value.  If @TRUE, arrow tails are
##     drawn as the corresponding arrow heads.  Defaults to @FALSE.}
##   \item{height}{A @numeric value, the (common) size of nodes.}
##   \item{lwd}{A @numeric value, the (common) width of edges.}
##   \item{cex}{A @numeric value, the relative size of the text for gene names.}
##   \item{...}{Further arguments to be passed to 'edgeRenderInfo' and
##     'nodeRenderInfo'.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##   A @list containing the following components:
##   \describe{
##     \item{graph}{The 'graph' object as plotted.}
##     \item{breaks}{The break points in the supplied values (can be used for
##       plotting a legend).}
##   }
## }
##
## @author
##
## \seealso{
##   @see "plotKEGGgraph"
##   @see "plot"
## }
##
## @examples "../incl/testOneGraph.Rex"
##
##*/########################################################################

plotValuedGraph <- function(graph, values=NULL, nodeLabels=nodes(graph), qMax=0.95, colorPalette=heat.colors(10), adjustColorRange=FALSE, symmetrizeArrows=FALSE, height=1, lwd=1, cex=1, ..., verbose=FALSE){
  
  ##par(oma=c( 0,0,0,4))

  ## Validate arguments

  ## Argument 'graph'
  if (!inherits(graph, "graph")) {
    throw("Argument 'graph' should derive from class 'graph'")
  }
  gnodes <- nodes(graph)
  nnodes <- length(gnodes)

  ## Argument 'values'
  values <- Arguments$getNumerics(values)
  vnodes <- names(values)
  if (length(values) && is.null(vnodes)) {
    throw("Names of argument 'values' should be non NULL")
  }

  ## Argument 'nodeLabels'
  nodeLabels <- Arguments$getCharacters(nodeLabels)
  if (length(nodeLabels) != nnodes) {
    throw("Length of argument 'nodeLabels' should match the number of nodes in the graph")
  }
  nLabels <- nodeLabels
  names(nLabels) <- gnodes

  ## Argument 'qMax'
  qMax <- Arguments$getNumeric(qMax)

  ## Argument 'colorPalette'
  colorPalette <- Arguments$getCharacters(colorPalette)

  ## Argument 'adjustColorRange'
  adjustColorRange <- Arguments$getLogical(adjustColorRange)

  ## Argument 'symmetrizeArrows'
  symmetrizeArrows <- Arguments$getLogical(symmetrizeArrows)

  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  } 

  verbose && cat(verbose, "Nodes and their labels")
  verbose && str(verbose, nLabels)

  ## Associate values to the corresponding nodes on the graph
  graphValues <- rep(NA, nnodes)
  names(graphValues) <- gnodes

  cnodes <- intersect(vnodes, gnodes)
  graphValues[match(cnodes, gnodes)] <- values[cnodes]

  if (length(values)) {
    if (adjustColorRange) {
      cs <- graphValues
    } else {  ## color range from all the values
      cs <- values
    }
    cs <- abs(cs)  ## enforce color scale symmetry
    MM <- quantile(cs, qMax, na.rm=TRUE)  ## try to avoid outliers
    
    ## truncate outliers
    graphValues[graphValues< -MM] <- -MM
    graphValues[graphValues> MM] <- MM
    
    breaks <- seq(from=-MM, to=MM, length=length(colorPalette))
    verbose && cat(verbose, "Color scale breaks")
    verbose && str(verbose, breaks)
    
    nodeCols <- level.colors(graphValues, at=breaks, col.regions=colorPalette)
    names(nodeCols) <- names(graphValues)
    verbose && cat(verbose, "Node colors")
    verbose && str(verbose, nodeCols)
  } else {
    breaks=NULL
  }

  ##par(mfrow=c(1,2))
  ##par(mar = c(5, 0, 0, 5))
  ##image(cbind(1L:length(pal)), col = pal, axes = FALSE)
  ##par(mar = c(0, 0, 0, 0))
  
  ed <- edgeData(graph)
  ke <- ed[[1]]$KEGGEdge
  if (!is.null(ke)) {  ## only way to know if graph is KEGGgraph-compliant
    ## BEGIN code borrowed from plotKEGGgraph
    subdisplay <- subtypeDisplay(graph)
    eLabel <- subdisplay["label", ]
    eCol <- subdisplay["color", ]
    eTextCol <- subdisplay["fontcolor", ]
    eLty <- subdisplay["style", ]
    eArrowhead <- subdisplay["arrowhead", ]
    eArrowhead[eArrowhead=="normal"] <- "normArrow"  
    if (ncol(subdisplay) == 1) {
      tmp <- colnames(subdisplay)[1]
      names(eLabel) <- names(eCol) <- names(eTextCol) <- tmp
      names(eLty) <- names(eArrowhead) <- tmp
    }
    edgeRenderInfo(graph) <- list(lty=eLty, col=eCol, textCol=eTextCol, 
                                  label=eLabel, arrowhead=eArrowhead, label=eLabel)
    if (symmetrizeArrows) {
      edgeRenderInfo(graph) <- list(arrowtail=eArrowhead)
    }
  }
  else
    if(is.NCIgraph(graph)) ## NCIgraph
      {
        eTypeDictionnary <- c('normal','tee')
        eColDictionnary <- c('red','blue')
        names(eTypeDictionnary) <- names(eColDictionnary) <- c('activation','inhibition')
        eTypes <- unlist(lapply(graph@edgeData@data,FUN=function(e) tolower(e$edgeType)))
        ERIarrowhead =eTypeDictionnary[eTypes]
        ERIcol =eColDictionnary[eTypes]
        eNames <- sapply(names(graph@edgeData@data),FUN=function(e) gsub(e,pattern='\\|',replacement='~'))
        names(ERIarrowhead) <- names(ERIcol) <- eNames
        edgeRenderInfo(graph) <- list(arrowhead=ERIarrowhead,col=ERIcol)
      }
    else
      {
        ## graphAM
        if (inherits(graph, "graphAM")) {
          ahd <- rep("normal", length(ed))
          names(ahd) <- names(ed)
     adjMat <- graph@adjMat
     ## not useful: adjacency matrix is not signed...
   }
  }
  graph <- layoutGraph(graph)
  nodeRenderInfo(graph) <- list(label=nLabels, height=height, cex=cex, ...)
  if (length(values)) {
    nodeRenderInfo(graph) <- list(fill=nodeCols,textCol="black")
  }
  edgeRenderInfo(graph) <- list(lwd=lwd, ...)
  renderGraph(graph)  
  ## END code borrowed from plotKEGGgraph

  ##par(oma=c( 0,0,15,1))# reset margin to be much smaller.
  ##image.plot(legend.only=TRUE, zlim=range(breaks), col=colorPalette, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=5) 
  ##set.panel() # reset plotting device

  invisible(list(graph=graph, breaks=breaks))
}

############################################################################
## HISTORY
## 2010-10-08
## o Now validating argument 'verbose'.
## 2010-09-17
## o Fixed node labels.
## 2010-09-16
## o Removed dependency on KEGGgraph.
## o Added option 'symmetrizeArrows'.
## 2010-09-07
## o Added option 'translateGeneIDs'.
## o Added Rdoc.
## o removed brewer.pal to avoid depending on RColorBrewer.
## o renamed 'shift' into 'values' for more general applicability.
## 2010-08-05
## o Color scale is now symmetric / 0.
## o Legend is not drawn within plotDERes anymore.
## 2010-08-04
## o BUG FIX: colors were wrong (due to a factor/character problem).
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction randomWAMGraph
##
## @title "Generates a random graph"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{nnodes}{A @numeric value, the desired number of nodes.}
##   \item{nedges}{A @numeric value, the desired number of edges.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##  An object of class \code{\link[=graphAM-class]{graphAM}}.
## }
##
## @author
##
## \seealso{
##   \code{\link[=graphAM-class]{graphAM}}.
## }
##
## @examples "../incl/randomWAMGraph.Rex"
##
##*/########################################################################

randomWAMGraph <- function(nnodes=5, nedges=nnodes, verbose=FALSE){
  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  } 

  i <- 0

  repeat{
    g <- randomEGraph(as.character(1:nnodes),edges=nedges)
    if(isConnected(g))
      break
    i <- i+1
    verbose && print(verbose, i)
  }

  g <- as(g,"graphAM")
}


############################################################################
## HISTORY
## 2010-10-08
## o Now validating argument 'verbose'.
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction graph.T2.test
##
## @title "Performs the Hotelling T2 test in Fourier space"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{X1}{A n1 x p @numeric @matrix, observed data for class 1: p variables, n1
##     observations.}
##   \item{X2}{A n2 x p @numeric @matrix, observed data for class 2: p variables, n2
##     observations.}
##   \item{G}{An object of class \code{\link[=graphAM-class]{graphAM}} or
##     \code{\link[=graphNEL-class]{graphNEL}}, the graph to be used in the two-sample test.}
##   \item{lfA}{A list returned by @see "laplacianFromA",
##     containing the Laplacian eigen vectors and eigen values}
##   \item{...}{Further arguments to be passed to @see "laplacianFromA".}
##   \item{k}{A @numeric value, number of Fourier components retained for the
##     test.}
## }
##
## \value{
##  A @list with class "htest", as returned by @see "T2.test".
## }
##
## @author
##
## \seealso{
##   @see "T2.test"
##   \code{\link[=graphAM-class]{graphAM}}
## }
##
## @examples "../incl/graph.T2.test.Rex"
##
##*/########################################################################
graph.T2.test <- function(X1, X2, G=NULL, lfA=NULL, ..., k=ncol(X1))
{
  tol <- 1e-8
  p <- ncol(X1)
  
  if (is.null(lfA))
    {
      if(is.null(G))
        A <- diag(rep(1,p))
      else
        A <- as(G, "graphAM")@adjMat
      
      ## Build basis based on subgraph Laplacian
      lfA <- laplacianFromA(A, ..., k=k)            
    }    

  U <- lfA$U
  ## print(U)
  egVal <- lfA$l
  kIdx <- (egVal <= max(egVal[k],tol)) #lfA$kIdx
  rk <- max(which(kIdx)) ## "round" the number of kept eigenvectors to take into account eigenvalue multiplicity
  ##print(egVal)
  ##print(U[,1:rk, drop=FALSE])
  ##print(X1[1:3,])
  ##print((X1%*%U[, 1:rk, drop=FALSE]))
  ## Perform the test in the new basis
  ut <- T2.test(X1%*%U[, 1:rk, drop=FALSE], X2%*%U[, 1:rk, drop=FALSE])
}

############################################################################
## HISTORY
## 2010-09-23
## o Added an example.
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction writeAdjacencyMatrix2KGML
##
## @title "Writes an adjacency matrix into an XML file"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{mat}{A @matrix, interpreted of the adjacency matrix of a graph.}
##   \item{pathname}{The full path name of the XML file to be written.}
##   \item{nodePrefix}{A @character value giving the prefix to which the node
##     index in 'mat' will be appended.}
##   \item{overwrite}{If @TRUE and file already exists, overwrite it.}
##   \item{...}{Further arguments to be passed to plotKEGGgraph.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##   None.
## }
##
## @author
##
## \seealso{
##   @see "parseKGML2Graph"
## }
##
## @examples "../incl/randomWAMGraph.Rex"
##
##*/########################################################################

writeAdjacencyMatrix2KGML <- function(mat, pathname, nodePrefix="n", overwrite=FALSE, ..., verbose=FALSE){
  ## Validate arguments

  ## Argument 'mat'
  if (!is.element("matrix", class(mat))) {
    throw("Argument 'mat' should be of class 'matrix'")
  }
  nc <- ncol(mat)
  nr <- nrow(mat)
  if (nr != nc) {
    throw("Argument 'mat' should be a *symmetric* matrix, but has ", nr, " rows and ", nc, " columns")
  }
  nnodes <- nr
  rm(nr, nc)
  
  ## Checking that 'mat' only has '-1', '0', and '1' values.
  nmat <- mat
  dim(nmat) <- NULL
  nmat <- Arguments$getIntegers(nmat, range=c(-1, 1))
  rm(nmat)
  
  ## Argument 'pathname'
  pathname <- Arguments$getCharacter(pathname)
  path <- dirname(pathname)
  path <- Arguments$getWritablePath(path)

  ## Argument 'nodePrefix'
  nodePrefix <- Arguments$getCharacter(nodePrefix)

  ## Argument 'overwrite'
  overwrite <- Arguments$getLogical(overwrite)
  if (!overwrite && file.exists(pathname)) {
    throw("File exists and will not be overwritten: ", pathname)
  }

  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  } 

  ## local 'cat' function:
  locCat <- function(..., append=TRUE) {
    cat(..., "\n", file=pathname, append=append)
  }

  ## nodes
  nodes <- seq(length=nnodes)
  nodeNames <- sprintf("%s%s", nodePrefix, nodes)

  edgeMap <- data.frame(key=c(-1, 1),
                        type=c("inhibition", "activation"),
                        label= c("-|", "-&gt;"))
  
  edgeList <- lapply(nodes, FUN=function(node) {
    mm <- match(mat[node, ], edgeMap[["key"]])
    idxs <- which(!is.na(mm))
    mm <- na.omit(mm)

    res <- nodes[idxs]
    attr(res, "type") <- edgeMap[mm, "type"]
    attr(res, "label") <- edgeMap[mm, "label"]
    res
  })
  names(edgeList) <- nodes
  
  ## write XML file header
  txt <- "<?xml version=\"1.0\"?>"
  locCat(txt, append=FALSE)
  txt <- "<!DOCTYPE pathway SYSTEM \"http://www.genome.jp/kegg/xml/KGML_v0.7.1_.dtd\">"
  locCat(txt)

  ## write pathway
  txt <- "<pathway name=\"path:dummy\" org=\"dummy\" number=\"1\">"
  locCat(txt)

  ## nodes
  entries <- seq(along=nodes)
  for (nn in entries) {
    txt <- sprintf("  <entry id=\"%s\" name=\"%s\" type=\"gene\">", nn, nodeNames[nn])
    locCat(txt)
    txt <- "  </entry>"
    locCat(txt)
  }

  ## edges
  edgesNames <- names(edgeList)
  for (ee1 in seq(along=edgeList)) {
    entry1 <- edgesNames[ee1]
    entries <- edgeList[[ee1]]
    types <- attr(entries, "type")
    labels <- attr(entries, "label")
    for (ee2 in seq(along=entries)) {
      entry2 <- entries[ee2]
      type <- types[ee2]
      label <- labels[ee2]
      txt <- sprintf("  <relation entry1=\"%s\" entry2=\"%s\" type=\"%s\">", entry1, entry2, "NA")
      locCat(txt)
      txt <- sprintf("    <subtype name=\"%s\" value=\"-%s\"/>", type, label)
      locCat(txt)
      txt <- "  </relation>"
      locCat(txt)
    }
  }
  txt <- "</pathway>"
  locCat(txt)
}
  
############################################################################
## HISTORY
## 2010-10-08
## o Now validating argument 'verbose'.
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction getKEGGPathways
##
## @title "Builds a graph for each of the KEGG pathways"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{path}{A @character value, the local _full_ path of KGML data.}
##   \item{rootPath}{A @character value, the local _root_ path of KGML data.}
##   \item{organism}{A @character value specifying the organism whose
##      pathways should be considered. Defaults to "hsa" (Homo Sapiens).}
##   \item{metaTag}{A @character value, specifying the type of pathways to
##     be considered ("metabolic" or "non-metabolic"). Defaults to "non-metabolic".}
##   \item{pattern}{An optional @character value specifying a file name pattern to
##     look for.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##   A @list containing a \code{\link[=graph-class]{graph}} object for each KEGG pathway with at least one edge.
## }
##
## \details{If 'path' is supplied, KGML files in this directory are loaded.
##   Otherwise, KGML files are assumed to be in
##   <rootPath>/<metaTag>/"organisms"/<organism>, which mirrors the
##  structure of the KEGG KGML file repository.
## }
##
## @author
##
## \seealso{
##   @see "parseKGML"
##   @see "KEGGpathway2Graph"
## }
##
## @examples "../incl/getKEGGPathways.Rex"
##
##*/###########################################################################

getKEGGPathways <- function(path=NULL, rootPath="networkData/ftp.genome.jp/pub/kegg/xml/kgml", organism="hsa", metaTag=c("non-metabolic", "metabolic"), pattern=NULL, verbose=FALSE) {
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Validate arguments
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'path':
  if (is.null(path)) {
    rootPath <- Arguments$getReadablePath(rootPath)
    metaTag <- match.arg(metaTag)
    organism <- match.arg(organism)
    path <- file.path(rootPath, metaTag, "organisms", organism)
  }
  path <- Arguments$getReadablePath(path)
  # Argument 'pattern':
  pattern <- Arguments$getCharacter(pattern)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  } 

  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Setup
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  if (length(pattern)) {
    patt <- sprintf("(%s)", pattern)
  } else {
    patt <- paste("^", organism, "([0-9]+).xml$", sep="")
  }

  filenames <- list.files(path, pattern=patt)
  if (!length(filenames)) {
    throw("No pathway found with pattern :'", patt, "' in directory ", path)
  }
  print(patt)
  pIds <- gsub(patt, "\\1", filenames)  ## pathway IDs
  verbose && cat(verbose, "Pathway IDs:")
  verbose && str(verbose, pIds)
    
  pathnames <- file.path(path, filenames)
  names(pathnames) <- pIds
  
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## get all KEGG pathways
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  pb <- ProgressBar(stepLength=100/length(pathnames))
  reset(pb)

  grList <- lapply(pathnames, FUN=function(pathname) {
    pw <- parseKGML(pathname)
    pwInfo <- getPathwayInfo(pw)
    gr <- KEGGpathway2Graph(pw, genesOnly=TRUE, expandGenes=TRUE)
    #attr(gr, "info") <- pwInfo
    gr@graphData$info <- pwInfo
    #attr(gr, "label") <- getTitle(pwInfo)
    gr@graphData$label <- getTitle(pwInfo)
    increase(pb)
    gr
  })

  verbose && cat(verbose, "KEGG pathways retrieved:")
  verbose && str(verbose, names(grList))
  
  ## remove those with 0 edges
  ne <- sapply(grList, numEdges)
  idxs <- which(ne==0)
  if (length(idxs)) {
    verbose && cat(verbose, "Discarding ", length(idxs), " pathways with 0 edges")
    grList <- grList[-idxs]
  }
  verbose && str(verbose, names(grList))

  return(grList)
}

############################################################################
# HISTORY:
## 2010-10-08
## o Now validating argument 'verbose'.
# 2010-09-23
# o Added a 'path' argument to load KGML files sitting in non-standard
##  directories.
# 2010-09-20
# o Added a 'pattern' argument.
# 2010-09-14
# o Clean-ups.
# o Now returning only a list of 'graph' elements (labels are passed as
#   attributes.
# o pathway labels are now inferred from the XML file, not from the
#   (unreliable) "KEGGPATHID2NAME" environment.
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction twoSampleFromGraph
##
## @title "Given a basis (typically the eigenvectors of a graph Laplacian), builds two multivariate normal samples with mean shift located in the first elements of the basis"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{n1}{An @integer value specifying the number of points in the first sample.}
##   \item{n2}{An @integer value specifying the number of points in the second sample.}
##   \item{shiftM2}{A @numeric value giving the desired squared Mahalanobis norm of the mean shift between the two samples.}
##   \item{sigma}{A matrix giving the covariance structure of each sample.}
##   \item{U}{A matrix giving the desired basis.}
##   \item{k}{An @integer value giving the number of basis elements in which the mean shift must be located.}
## }
##
## \value{ A @list with named elements:
##  \describe{
##    \item{X1}{The first sample in the original basis (before transformation by U).}
##    \item{X2}{The second sample in the original basis (before transformation by U).}
##    \item{X1}{The first sample in the specified basis (after transformation by U).}
##    \item{X2}{The second sample in the specified basis (after transformation by U).}
##    \item{mu1}{The population mean of F1}
##    \item{mu2}{The population mean of F2}
##    \item{diff}{mu1 - mu2}
##   }
##  }
##
## @author
##
## @examples "../incl/randomWAMGraph.Rex"
##
##*/########################################################################

twoSampleFromGraph <-
function(n1=20, n2=n1, shiftM2=0, sigma, U, k=ceiling(ncol(U)/3)){
  p = nrow(U)

  ## Generate two samples in Fourier space

  diff <- rep(0,p)

  diff[1:k] <- rnorm(k)

  ## tmp <- rnorm(k)
  ## diff[1:k] <- shift*tmp/sqrt((t(tmp)%*%tmp))
  rawShiftNorm <- t(diff)%*%solve(sigma)%*%diff
  diff[1:k] <- sqrt(shiftM2)*diff[1:k]/sqrt(rawShiftNorm)  ## so that the norm of this shift is shiftM2 !

  mu1 <- rnorm(p)
  mu2 <- mu1 + diff

  F1 <- rmvnorm(n=n1, mean=mu1, sigma=sigma, method="chol")
  F2 <- rmvnorm(n=n2, mean=mu2, sigma=sigma, method="chol")

  ## Build the inverse Fourier transform from A
  ## iDs <- diag(1/sqrt(rowSums(abs(A))))
  ## L <- diag(rep(1,p)) - (iDs %*% A %*% iDs) # Normalized version
  ## D <- diag(rowSums(abs(A)))
  ## L <- D - A # Unormalized version
  ## edL <- eigen(L)
  ## U <- edL$vectors

  ## Return the data in the graph space

  X1 <- F1 %*% t(U)
  X2<- F2 %*% t(U)

  list(X1=X1,X2=X2,F1=F1,F2=F2,mu1=mu1,mu2=mu2,diff=diff)

}

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction laplacianFromA
##
## @title "Calculates the Laplacian associated to an adjacency matrix"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{A}{The adjacency matrix of the graph.}
##   \item{k}{...}
##   \item{ltype}{A @character value specifying the type of Laplacian to be
##     calculated.  Defaults to meanInfluence.}
## }
##
## \value{
##  A @list containing the following components:
##  \describe{
##    \item{U}{Eigenvectors of the graph Laplacian.}
##    \item{l}{Eigenvalues of the graph Laplacian}
##    \item{kIdx}{Multiplicity of '0' as eigenvalue.}
##   }
## }
##
## @author
##
## @examples "../incl/randomWAMGraph.Rex"
##
##*/########################################################################

## Types: unnormalized, normalized, meanInfluence, totalInfluence

laplacianFromA <- function(A, k=1, ltype=c("meanInfluence", "normalized", "unnormalized", "totalInfluence")) {
  ltype <- match.arg(ltype)
  tol <- 1e-8
  rownames(A) <- NULL
  colnames(A) <- NULL

  ltype <- match.arg(ltype)

  ##if (!isSymmetric.matrix(A)) {
  ##  print(A)
  ##  throw("Argument 'A' must be a symmetric matrix")
  ##}
  
  p <- nrow(A)
  I <- diag(rep(1,p))

  if(ltype %in% c("normalized","unnormalized")) # A must be made symmetric
    {
      tsIdx <- ((A == 0) & (t(A) != 0))
      A[tsIdx] <- t(A)[tsIdx]
    }
  
  if(ltype == "normalized")
    {
      iDs <- diag(1/sqrt(rowSums(abs(A))))
      L <- I - (iDs %*% A %*% iDs)
    }

  if(ltype == "unnormalized")
    {
      D <- diag(rowSums(abs(A)))
      L <- D - A
    }
              
  if(ltype == "meanInfluence")
    {
      ImA <- diag(as.integer(rowSums(abs(t(A))) != 0)) - diag(1/pmax(1,rowSums(abs(t(A)))))%*%t(A)
      L <- t(ImA)%*%ImA
    }

  if(ltype == "totalInfluence")
    {
      ImA <- diag(as.integer(rowSums(abs(t(A))) != 0)) - t(A)
      L <- t(ImA)%*%ImA
    }  

  edL <- eigen(L, symmetric=TRUE)
  egVal <- rev(edL$values)
  kIdx <- (egVal <= max(egVal[k], tol))
  return(list(U=edL$vectors[,ncol(edL$vectors):1], l=egVal, kIdx=kIdx))
}

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
# @RdocFunction testOneGraph
##
## @title "Applies a serie of two-sample tests to each connected component
##   of a graph using various statistics"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{graph}{A \code{\link[=graph-class]{graph}} object.}
##   \item{data}{A 'matrix' (size: number 'p' of genes x number 'n' of samples) of gene expression.}
##   \item{classes}{A 'vector' (length: 'n') of class assignments.}
##   \item{useInteractionSigns}{A @logical value indicating whether the sign of interaction should be taken into account.}
##   \item{...}{Further arguments to be passed to testOneConnectedComponent.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##  A structured @list containing the p-values of the tests, the 
##  \code{\link[=graph-class]{graph}} object of the connected component and the number of 
##  retained Fourier dimensions.
## }
##
## @author
##
## \seealso{
##   @see "testOneConnectedComponent"
## }
##
## @examples "../incl/testOneGraph.Rex"
##
##*/########################################################################

testOneGraph <- function(graph, data, classes, useInteractionSigns=TRUE, ..., verbose=FALSE) {
  ## 'graph': an object of class 'graph' or 'graphAM' or 'graphNEL'.
  ## 'data': a 'matrix' (size: number 'p' of genes x number 'n' of samples) of gene expression
  ## 'classes': a 'vector' (length: 'n') of class assignments
  ## 'useInteractionSigns': should the sign of interaction be taken into account ?
  ## '...': further arguments to be passed to testOneConnectedComponent

  ## - - - - - - - - - - - - - - - - - - -
  ## Validate arguments
  ## - - - - - - - - - - - - - - - - - - -
  ## Argument 'classes'
  classes <- Arguments$getNumerics(classes)
  ll <- length(unique(classes))
  if (ll != 2) {
    throw("Number of classes should be 2, not ", ll)
  }
  rm(ll)

  ## Argument 'data'
  cls <- class(data)[1]
  if (cls != "matrix") {
    throw("Arguments 'data' should be a 'matrix', not a ", cls)
  }
  n <- ncol(data)
  nc <- length(classes)
  if (n != nc) {
    throw("Number of samples in 'data' (", n, ") should match number of samples in 'classes' (", nc, ")")
  }
  rm(nc)

  ## Argument 'graph'
  if (!validGraph(graph)) {
    throw("Argument 'graph' is not a valid graph object")
  }

  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  } 
  
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## 1. Keep only expression data from nodes in the graph
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Keeping genes in the graph *and* the expression data set")
  dataGN <- rownames(data)
  if(is.NCIgraph(graph))
    {
      graphGN <- translateNCI2GeneID(graph)
      names(graphGN) <- NULL
    }
  else
    graphGN <- translateKEGGID2GeneID(nodes(graph))
  commonGN <- intersect(dataGN, graphGN)

  mm <- match(graphGN, commonGN)
  ww <- which(is.na(mm))
  ll <- length(ww)
  if (ll) {
    verbose && cat(verbose, ll, " genes of the graph were not found in the expression data set: ")
    verbose && str(verbose, graphGN[ww])
  }
  ## sorting (and subsetting if necessary)
  mm <- match(commonGN, graphGN)
  graph <- subGraph(nodes(graph)[mm], graph)
  if (!validGraph(graph)) {
    throw("Argument 'graph' is not a valid graph object")
  }

  mm <- match(dataGN, commonGN)
  ww <- which(is.na(mm))
  ll <- length(ww)
  if (ll) {
    verbose && cat(verbose, ll, " genes of the expression data set are absent from the graph: ")
    verbose && str(verbose, dataGN[ww])
  }
  mm <- match(commonGN, dataGN)
  ## sorting (and subsetting if necessary)
  data <- data[mm, , drop=FALSE]

  ## sanity check (ordering should be the same now)
  if(is.NCIgraph(graph))
    {
      graphGN <- translateNCI2GeneID(graph)
      names(graphGN) <- NULL
    }
  else
    graphGN <- translateKEGGID2GeneID(nodes(graph))
  dataGN <- rownames(data)
  stopifnot(all.equal(dataGN, graphGN))

  ## TODO: Rename graph nodes (so that testOneConnectedComponent is not KEGGGraph-specific)
  ##   nodes(graph) <- graphGN
  ## currently cannot be done because we're using getSubtypeDisplay to get the interaction info
  ## and it is not updated when node name change.
  ## OK, we'll do it the other way around:
  rownames(data) <- nodes(graph)

  rm(graphGN)
  rm(dataGN)
  verbose && exit(verbose)

  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## 2. Retrieve interaction signs (if required)
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (useInteractionSigns) {
    tt <- try(graph <- getSignedGraph(graph, verbose=verbose))
    if (class(tt)=="try-error") {
      warning("Failed to retrieve interaction sign information: returning NULL")
      return(NULL)
    }
  }

  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## After 1. and 2. the graph may have several connected components
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  graphList <- getConnectedComponentList(graph, verbose=verbose)
  verbose && cat(verbose, "Found ", length(graphList), " connected component(s)")
  gsizes <- sapply(graphList, numNodes)
  w1 <- which(gsizes==1)
  if (length(w1)) {
    verbose && cat(verbose, "Excluding ", length(w1), " components with only one node from further analysis")
    graphList <- graphList[-w1]
  }

  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## sign information has been lost in subsetting...
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (useInteractionSigns) {
    graphList <- lapply(graphList, getSignedGraph, verbose=verbose)
  }

  res <- lapply(graphList, testOneConnectedComponent, data, classes, ..., verbose=verbose)
  res
}

############################################################################
## HISTORY:
## 2011-03-06
## o Dealing with NCI graphs
## 2010-10-08
## o Now validating argument 'verbose'.
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction hyper.test
##
## @title "Performs an hypergeometric test of enrichment of a set of
##   hypotheses in significant elements"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{p.values}{A named @numeric vector giving the p-values of all
##     tested elements.}
##   \item{testSet}{A @character vector giving the ids of the elements in the
##     tested set. Elements of 'testSet' must have a match in 'names(p.values)'.}
##   \item{thr}{A @numeric value between 0 and 1 giving the threshold on
##     p-values at which an element is declared to be significant.}
##   \item{universe}{An @integer value giving the number of elelments in the
##     considered universe.  Defaults to 'length(p.values)'.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{
##  A @list with class "htest" containing the following components:
##  \describe{
##    \item{statistic}{A @numeric value, the test statistic.}
##    \item{p.value}{A @numeric value, the corresponding p-value.}
##   }
## }
##
## @author
##
## \seealso{
##   @see "AN.test"
##   @see "BS.test"
##   @see "graph.T2.test"
## }
##
## @examples "../incl/tests.Rex"
##
##*/########################################################################

hyper.test <- function(p.values, testSet, thr=0.001, universe=length(p.values), verbose=FALSE) {
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Validate arguments
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Argument 'p.values'
  p.values <- Arguments$getNumerics(p.values)
  pnames <- names(p.values)
  pnames <- Arguments$getCharacters(pnames)
  if (length(pnames)==0) {
    throw("'names(p.values)' should not be NULL for a hypergeometric test to be performed.")
  }

  ## Argument 'testSet'
  testSet <- Arguments$getCharacters(testSet)
  if (length(testSet)==0) {
    throw("'testSet' should have at least one element for a hypergeometric test to be performed.")
  }
  ## Argument 'thr'
  thr <- Arguments$getNumeric(thr)

  ## Argument 'universe'
  universe <- Arguments$getNumeric(universe)

  ## Argument 'verbose'
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    cat <- R.utils::cat
    pushState(verbose)
    on.exit(popState(verbose))
  } 

  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Hypergeometric testing
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  mm <- match(testSet, pnames)
  isNA <- is.na(mm)
  idxs <- which(isNA)
  if (length(idxs)) {
    verbose && cat(verbose, "Elements of 'testSet' not found in 'p.values':")
    verbose && str(verbose, pnames[idxs])
  }
  idxs <- which(!isNA)
  mm <- mm[idxs]
  p <- length(mm)
  if (p==0) {
    warning("No elements of 'testSet' found in 'p.values':  returning NA.")
    qHG <- NA
    pHG <- NA
  } else {
    qHG <- sum(p.values[mm] < thr) # How many significant elements in the set
    mHG <- p # How many elements in the set
    nHG <- universe - p # How many elements outside the set
    kHG <- sum(p.values < thr)# How many significant elements in total
    pHG <- 1-phyper(qHG, mHG, nHG, kHG)
  }
  res <- list(statistic=qHG,  p.value=pHG)
  class(res) <- "htest"
  res
}

############################################################################
## HISTORY
## 2010-10-08
## o Now validating argument 'verbose'.
## 2010-09-25
## o Arguments are now validated.
## o Now returning NA when no elements of 'testSet' is in 'p.values'.
## o Now throwing an error when 'names(p.values)' is NULL.
## 2010-09-23
## o Added an example.
## o Made more generic by replacing 'gene' by 'element', 'DE' by
##   'significant', and 'gene set' by 'set'.
## o Now returns an object of class "htest".
############################################################################

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction getConnectedComponentList
##
## @title "Given a graph, returns a list of its connected components
## (which are also graph objects), ordered by decreasing number of
## nodes"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{graph}{A \code{\link[=graph-class]{graph}} object.}
##   \item{verbose}{If @TRUE, extra information is output.}
## }
##
## \value{ A @list containing a \code{\link[=graph-class]{graph}} object for each connected
##  component of the input graph, ordered by decreasing number of nodes
##  }
##
## @author
##
## \seealso{@see "connectedComp".}
##
## @examples "../incl/getSignedGraph.Rex"
##
##*/#########################################################################

getConnectedComponentList <- function(graph, verbose=FALSE) {
  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  } 

  nodeList <- connectedComp(graph)
  sizes <- sapply(nodeList, length)
  oo <- order(sizes, decreasing=TRUE)
  graphList <- lapply(nodeList[oo], subGraph, graph)
  verbose && print(verbose, graphList)
  graphList
}

############################################################################
## HISTORY:
## 2010-10-08
## o Now validating argument 'verbose'.
## 2010-05-01
## o Created.
############################################################################

## Libraries
library(R.utils)
library(R.menu) ## source("http://aroma-project.org/hbLite.R") hbLite("R.menu")
## library(aroma.core) ## for 'stext'.... TODO: remove this dependency

require(graph)
require(mvtnorm) ## for 'rmvnorm'
require(rrcov) ## for 'T2.test'
require(corpcor)

require(KEGGgraph)
require(KEGG.db)
require(Rgraphviz)
require(RBGL)

library(fields) # For image.plot called in plotValuedGraph
## library(limma) # For venn diagrams

require(lattice)
require(marray)
require(RColorBrewer)

## library(XML) ## ?

verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

## Copyright 2010 Laurent Jacob, Pierre Neuvial and Sandrine Dudoit.

## This file is part of DEGraph.

## DEGraph is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## DEGraph is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with DEGraph.  If not, see <http://www.gnu.org/licenses/>.

#########################################################################/**
## @RdocFunction AN.test
##
## @title "Performs the Adaptive Neyman test of Fan and Lin (1998)"
##
## \description{
##  @get "title".
## }
##
## @synopsis
##
## \arguments{
##   \item{X1}{A n1 x p @matrix, observed data for class 1: p variables, n1
##     observations.}
##   \item{X2}{A n2 x p @matrix, observed data for class 2: p variables, n2
##     observations.}
##   \item{candK}{A @vector, candidate values for the true number of Fourier
##     components.}
##   \item{na.rm}{A @logical value indicating whether variables with @NA in
##     at least one of the n1 + n2 observations should be discarder before
##     the test is performed.}
## }
##
## \value{
##  A @list with class "htest" containing the following components:
##  \describe{
##    \item{statistic}{A @numeric value, the test statistic.}
##    \item{p.value}{A @numeric value, the corresponding p-value.}
##    \item{kstar}{A @numeric value, the estimated true number of Fourier
##      components.}
##   }
## }
##
## @author
##
## \seealso{
##   @see "BS.test"
##   @see "graph.T2.test"
##   @see "hyper.test"
## }
##
## @examples "../incl/tests.Rex"
##
##*/########################################################################

AN.test <- function(X1, X2, candK=1:ncol(X1), na.rm=FALSE) {
  if (na.rm) {
    na1 <- apply(X1, 2, FUN=function(x) sum(is.na(x)))
    na2 <- apply(X2, 2, FUN=function(x) sum(is.na(x)))
    idxs <- which((na1==0) & (na2==0))
    X1 <- X1[, idxs]
    X2 <- X2[, idxs]    
  }
  p <- ncol(X1)
  n1 <- nrow(X1)
  n2 <- nrow(X2)
  Tstar <- -Inf
  kstar <- NA
  for (kk in candK) {
    var1 <- mean(diag(var(X1[, 1:kk, drop=FALSE])))
    var2 <- mean(diag(var(X2[, 1:kk, drop=FALSE])))
    X <- colMeans(X1[, 1:kk, drop=FALSE]) - colMeans(X2[, 1:kk, drop=FALSE])
    X <- X/sqrt(var1/n1 + var2/n2)
    tmp <- sum(X^2 - 1)/sqrt(2*kk)
    if (tmp > Tstar) {
      Tstar <- tmp
      kstar <- kk
    }
  }
  T <- sqrt(2*log(log(p)))*Tstar - (2*log(log(p)) + log(log(log(p)))/2 - log(4*pi)/2)
  p <- 1-exp(-exp(-T)) ## Gumbel cdf
  res <- list(statistic=T,  p.value=p, kstar=kstar)
  class(res) <- "htest"
  res
}

############################################################################
## HISTORY
## 2010-09-23
## o Added an example.
## o Added an option to remove NA:s.
## 2010-09-22
## o Now returns an object of class "htest".
## o Gumbel cdf is now calculated manually to avoid dependency 'evd'.
############################################################################

## Bioconductor packages
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("Rgraphviz")
BiocManager::install("KEGGgraph")
BiocManager::install("marray")

## CRAN packages
install.packages("rrcov")
install.packages("corpcor")
install.packages("RBGL")
install.packages("fields")

## HB's packages
source("http://www.braju.com/R/hbLite.R")
hbLite("R.utils")

library(R.utils)
library(DEGraph)

## Set default author
author <- "Laurent Jacob, Pierre Neuvial and Sandrine Dudoit"
     
setwd("R")
sourceDirectory(".")
rdocFiles <- list.files(".", full.names=TRUE)

## Compile the Rdoc:s into Rd files (saved in the destPath directory)
destPath <- "../man"
destPath <- Arguments$getWritablePath(destPath)
dummy <- lapply(rdocFiles, Rdoc$compile, destPath=destPath)
     
## List the generated Rd files
rdFiles <- list.files(destPath, full.names=TRUE)
print(rdFiles)
     
## Show one of the files
## file.show(rdFiles[1])
     
## Clean up
setwd("..")

library(R.utils)
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

## setup
srcRootPath <- "http://www.stat.berkeley.edu/~pierre/share"

dataSet <- "Loi08"
chipType <- "HG-U133A+B"

ttTags <- c("tam", "untreated")
outTags <- c("metastasis", "relapse")

if (!exists("force", mode="character")) {
  force <- FALSE
}

verbose && enter(verbose, "Downloading expression data")
path <- file.path("exprData", dataSet, chipType)

srcPath <- file.path(srcRootPath, path)
tgtPath <- path
tgtPath <- Arguments$getWritablePath(tgtPath)

for (ttTag in ttTags) {
  filename <- sprintf("%s,%s,geneLevel,median.xdr", dataSet, ttTag)
  srcPathname <- file.path(srcPath, filename)
  tgtPathname <- file.path(tgtPath, filename)
  
  pn <- downloadFile(srcPathname, tgtPathname, overwrite=force, verbose=verbose)
}
verbose && exit(verbose)

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Annotation data (classes)
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

verbose && enter(verbose, "Downloading annotation data (classes of patients)")
path <- file.path("annotationData/samples", dataSet)

srcPath <- file.path(srcRootPath, path)
tgtPath <- path
tgtPath <- Arguments$getWritablePath(tgtPath)

for (ttTag in ttTags) {
  for (outTag in outTags) {
    filename <- sprintf("%s,%s,%s.xdr", dataSet, outTag, ttTag)
    srcPathname <- file.path(srcPath, filename)
    tgtPathname <- file.path(tgtPath, filename)
  
    pn <- downloadFile(srcPathname, tgtPathname, skip=!force, overwrite=force, verbose=verbose)
  }
}
verbose && exit(verbose)

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Annotation data (classes)
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

verbose && enter(verbose, "Downloading gene and probe annotation data")
path <- file.path("annotationData/chipTypes", chipType)

srcPath <- file.path(srcRootPath, path)
tgtPath <- path
tgtPath <- Arguments$getWritablePath(tgtPath)

pTags <- c("probes", "genes")
for (pTag in pTags) {
  filename <- sprintf("%s,%s,from%s.xdr", chipType, pTag, dataSet)
  srcPathname <- file.path(srcPath, filename)
  tgtPathname <- file.path(tgtPath, filename)
  
  pn <- downloadFile(srcPathname, tgtPathname, skip=!force, overwrite=force, verbose=verbose)
}
verbose && exit(verbose)

############################################################################
# HISTORY:
# 2010-09-17
# o Added gene and probe annotation data.
# 2010-09-14
# o Created.
############################################################################

## - - - - - - - - - - - - - - - - - - -
## Setup
## - - - - - - - - - - - - - - - - - - -

## exprData/
##   Loi08/
##     HG-U133A+B/
##       Loi08,tam,geneLevel,median.xdr
##       Loi08,untreated,geneLevel,median.xdr
##
## annotationData/
##   samples/
##     Loi08/
##       Loi08,metastasis,tam.xdr
##       Loi08,metastasis,untreated.xdr
##       Loi08,relapse,tam.xdr
##       Loi08,relapse,untreated.xdr

dataSet <- "Loi08"
chipType <- "HG-U133A+B"

## - - - - - - - - - - - - - - - - - - -
## Setup
## - - - - - - - - - - - - - - - - - - -
lev <- "gene"                                 ## gene-level expression data
treat <- c("tam", "untreated")[1]             ## Tamoxifen treated patients
outcome <- c("relapse", "metastasis")[2]       ## Metastasis/non metastasis/NA

## - - - - - - - - - - - - - - - - - - -
## Load gene expression data
## - - - - - - - - - - - - - - - - - - -

expPath <- "exprData"
expPath <- Arguments$getReadablePath(expPath)

path <- file.path(expPath, dataSet, chipType)
path <- Arguments$getReadablePath(path)

pattern <- sprintf("%s,%s,%s", dataSet, treat, lev)
filename <- list.files(path, pattern=pattern)
pathname <- file.path(path, filename)

exprData <- loadObject(pathname)

## - - - - - - - - - - - - - - - - - - - - - - - - - -
## Load class information
## - - - - - - - - - - - - - - - - - - - - - - - - - -
annPath <- "annotationData"
annPath <- Arguments$getWritablePath(annPath)

path <- file.path(annPath, "samples", dataSet)
path <- Arguments$getReadablePath(path)

pattern <- sprintf("%s,%s,%s", dataSet, outcome, treat)
filename <- list.files(path, pattern=pattern)
pathname <- file.path(path, filename)

classData <- loadObject(pathname)
## sanity check
stopifnot(names(classData)==colnames(exprData))

## - - - - - - - - - - - - - - - - - - - - - - - - - -
## Load gene annotation information
## - - - - - - - - - - - - - - - - - - - - - - - - - -
annPath <- "annotationData"
annPath <- Arguments$getWritablePath(annPath)

path <- file.path(annPath, "chipTypes", chipType)
path <- Arguments$getReadablePath(path)
filename <- sprintf("%s,genes,from%s.xdr", chipType, dataSet)
pathname <- file.path(path, filename)

annData <- loadObject(pathname)
## sanity check
stopifnot(all.equal(rownames(annData), rownames(exprData)))

## discard NA:s
ww <- which(!is.na(classData))
exprData <- exprData[, ww]
classData <- classData[ww]

verbose && cat(verbose, "exprData:")
verbose && str(verbose, exprData)

verbose && cat(verbose, "classData:")
verbose && str(verbose, classData)

verbose && cat(verbose, "annData:")
verbose && str(verbose, annData)

############################################################################
# HISTORY:
# 2010-09-17
# o Added gene annotation data.
# 2010-09-13
# o Created.
############################################################################

%\VignetteIndexEntry{DEGraph: differential expression testing for gene networks}
%\VignettePackage{DEGraph}

\documentclass[11pt]{article}

\usepackage{times}
\usepackage{hyperref}
\usepackage{geometry}
\usepackage{natbib}
\usepackage[pdftex]{graphicx}
\SweaveOpts{keep.source=TRUE,eps=TRUE,pdf=TRUE,prefix=TRUE} 

% R part
\newcommand{\R}[1]{{\textsf{#1}}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Metas}[1]{{\texttt{#1}}}

\begin{document}
\title{DEGraph: differential expression testing for gene networks}
\author{Laurent Jacob \and Pierre Neuvial \and Sandrine Dudoit}

\maketitle
\begin{abstract}
  \Rpackage{DEGraph} implements recent hypothesis testing methods
  which directly assess whether a particular gene network is
  differentially expressed between two conditions. This is to be
  contrasted with the more classical two-step approaches which first
  test individual genes, then test gene sets for enrichment in
  differentially expressed genes. These recent methods take into
  account the topology of the network to yield more powerful detection
  procedures. In practice, \Rpackage{DEGraph} makes it very simple to
  test all KEGG pathways for differential expression on any gene
  expression data set and provides tools to visualize the results.
\end{abstract}

\section{Introduction}
Measuring gene expressions to study a biological phenomenon or build
prognosis tools is now common practice. Technologies like DNA
microarrays or RNA-Seq allow to systematically measure the expression
of thousands of genes in a sample. Statistical univariate statistical
procedures like the t-test are then classically applied to detect
differentially expressed genes. However when analyzing this type of
data, one is very often interested in the ``systems biology'' approach
of detecting pre-defined sets of genes that are known to work together
and are significantly differentially expressed between the studied
conditions. Two paradigms have been used so far~:
\begin{itemize}
\item Most approaches are two-step. They start by assessing which
  genes are differentially expressed, then test gene sets for
  enrichment in differentially expressed genes.
  % TODO: cite hypergeometric tests, gsea.
\item Some approaches directly use multivariate statistics on gene
  sets as vectors of genes to determine whether the multivariate
  expression of a gene set varies between groups of samples.
\end{itemize}
Limitations of the former approach have been widely
studied~\citep{Goeman2007Analyzing}~: that the former family of
approaches can lead to incorrect interpretations, as the sampling
units for the tests in the second step become the genes (as opposed to
the patients) and these are expected to have strongly correlated
expression measures. This suggests that direct multivariate testing of
gene set differential expression is more appropriate than posterior
aggregation of individual gene-level tests. On the other hand, while
multivariate statistics are known to perform well in small dimensions,
they lose power very quickly with increasing
dimension~\citep{Bai1996Effect}. 

At the same time, an increasing number of regulation networks are
becoming available, specifying, for example, which genes activate or
inhibit the expression of which other genes. The method implemented in
\Rpackage{DEGraph} intends to use these networks to build spaces of
lower dimension, yet retaining most of the expression shift of gene
sets. This makes the multivariate testing amenable and provably more
powerful under (partly) coherent expression shift assumption.

\section{Software features}

\Rpackage{DEGraph} offers the following functionalities:
\begin{description}
\item[Multivariate testing] \Rpackage{DEGraph} proposes functions to
  test whether a set of genes organised in a particular network are
  differentially expressed between two conditions (according to a
  particular data set of samples).
\item[Interfacing with KEGGgraph] The package also provides functions
  to easily load a set of KEGG networks as \Robject{KEGGgraph} objects
  and systematically test each of their connected components for
  differential expression with various statistics.  
\item[Visualization] 
  \Rpackage{DEGraph} provides functions to
visualize tested KEGG graphs with nodes colored according to a
quantitative variable, typically the individual t-statistics or mean
difference of expression between the two conditions for each gene.
\end{description}

\section{Case studies}

We now show on a simple example how \Rpackage{DEGraph} can be used to
assess differential expression of some KEGG pathways using several
test statistics, compare and plot the results.

\subsection{Loading the library and the data}

We load the \Rpackage{DEGraph} package by typing or pasting the
following codes in R command line:
<<lib, echo=TRUE>>=
library(DEGraph)
@ 

We then load some more libraries~:
<<morelib, echo=TRUE>>=
library("R.utils")
##library(graph)
##library(rrcov) ## for 'T2.test'
library(corpcor)
library(KEGGgraph)
library(Rgraphviz)
##library(RBGL)
library(fields) # For image.plot called in plotValuedGraph
library(lattice)
library(marray)
verbose <- TRUE
@ 

In this example, the expression and annotation data as well as the
list of KEGG networks has been pre-stored in an \texttt{.RData} file
to avoid lengthy downloading and formatting. For examples on how to
build these variables, see the \texttt{Loi2008} demo in the package.

<<data, echo=TRUE>>=
data("Loi2008_DEGraphVignette", package="DEGraph")
classData <- classLoi2008
exprData <- exprLoi2008
annData <- annLoi2008
grList <- grListKEGG
@ 

\subsection{Hypothesis testing}

We now run several tests on the expression data restricted to the two
selected KEGG networks stored in \Robject{grListKEGG}. We start with
individual t-tests on all the genes, which will later be used for
visualization.

<<ttests, echo=TRUE>>=
## Individual t-test p-values
X1 <- t(exprData[, classData==0])
X2 <- t(exprData[, classData==1])
ttpv <- c()
tts <- c()
for(i in 1:ncol(X1)) {
  tt <- t.test(X1[,i],X2[,i])
  ttpv[i]=unlist(tt$p.value)
  tts[i]=unlist(tt$statistic)
}
names(ttpv) <- names(tts) <- rownames(exprData)
@ 

We then run two different multivariate tests on each network:
\begin{itemize}
\item Hotelling $T^2$ test, which generalizes the t-test to
  multivariate data, and does not make use of the network information.
\item Hotelling $T^2$ test in a space of lower dimension built from
  the network structure.
\end{itemize}

<<mvtests, echo=TRUE>>=
prop <- 0.2
## Multivariate tests
resList <- NULL
for (ii in seq(along=grList)) {
  gr <- grList[[ii]]
  res <- testOneGraph(gr, exprData, classData, verbose=verbose, prop=prop)
  resList <- c(resList, list(res))
}
resNames <- names(grList)
pLabels <- sapply(grList, attr, "label")

## get rid of NULL results (no connected component of size > 1)
isNULL <- sapply(resList, is.null)
if (sum(isNULL)) {
  grList[isNULL]
  resList <- resList[!isNULL]
  resNames <- names(grList)[!isNULL]
  pLabels <- pLabels[!isNULL]
}

resL <- sapply(resList, length)
graphNames <- rep(resNames, times=resL)
pathwayNames <- rep(pLabels, times=resL)

graphList <- NULL
for (res in resList) {
  grl <- lapply(res, FUN=function(x) {
    x$graph
  })
  graphList <- c(graphList, as.list(grl))
}

ndims <- NULL
for (res in resList) {
  ndim <- sapply(res, FUN=function(x) {
    x$k
  })
  ndims <- c(ndims, ndim)
}

pKEGG <- NULL
for (res in resList) {
  pp <- sapply(res, FUN=function(x) {
    x$p.value
  })
  pKEGG <- cbind(pKEGG, pp)
}
colnames(pKEGG) <- graphNames
rn <- rownames(pKEGG)
rownames(pKEGG)[grep("Fourier", rn)] <- paste("T2 (", round(100*prop), "% Fourier components)", sep="")

if (exists("maPalette", mode="function")) {
  pal <- maPalette(low="red", high="green", mid="black", k=100)
} else {
  pal <- heat.colors(100)
}
shift <- tts # Plot t-statistics
names(shift) <- translateGeneID2KEGGID(names(tts))
fSignif <- which(pKEGG[2,] < 0.05)
fSignif <- fSignif[order(pKEGG[2,fSignif])]
@

Finally we plot two of the tested networks along with the p-value for
differential expression for each of the two multivariate
statistics. Node colors correspond to the gene t-statistic~:

<<path1, echo=TRUE, fig=FALSE>>=
gIdx <- fSignif[1]
gr <- graphList[[gIdx]]
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.3, verbose=verbose)
stext(side=3, pos=0, pathwayNames[gIdx])
ps <- signif(pKEGG[, gIdx],2)
txt1 <- paste("p(T2)=", ps[1], sep="")
txt2 <- paste("p(T2F[", ndims[gIdx], "])=", ps[2], sep="")
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
image.plot(legend.only=TRUE, zlim=range(res$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3) 
@

<<path2, echo=TRUE, fig=FALSE>>=
gIdx <- fSignif[5]
gr <- graphList[[gIdx]]
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
res <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, cex=0.3, verbose=verbose)
stext(side=3, pos=0, pathwayNames[gIdx])
ps <- signif(pKEGG[, gIdx],2)
txt1 <- paste("p(T2)=", ps[1], sep="")
txt2 <- paste("p(T2F[", ndims[gIdx], "])=", ps[2], sep="")
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
image.plot(legend.only=TRUE, zlim=range(res$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3) 
@

\begin{figure}
  \begin{center}
<<showpath1,echo=FALSE,fig=TRUE>>=
<<path1>>
@ 
  \end{center}
\caption{Pathway 1.}
\label{fig:path}
\end{figure}

\begin{figure}
  \begin{center}
<<showpath2,echo=FALSE,fig=TRUE>>=
<<path2>>
@ 
  \end{center}
\caption{Pathway 2.}
\label{fig:path2}
\end{figure}

\bibliographystyle{plainnat}
\bibliography{bibli}


\end{document}

\name{annLoi2008}
\docType{data}
\alias{annLoi2008}
\title{Annotation data used in the DEGraph package vignette}
\description{This data set gives NCBI, Hugo and alternative gene symbols
  along with the cytoband and description for the 227 genes used in the
  DEGraph package vignette. This comes from the 15737 gene, 255 patient
  dataset of Loi et al. (2008) which was used to study resistance to
  tamoxifen treatment in hormone-dependent breast cancer.  }
\usage{annLoi2008}
\format{A matrix of 227 lines and 5 columns.}
\examples{
data("Loi2008_DEGraphVignette")

dim(annLoi2008)
head(annLoi2008)
}
\source{
  Loi et al.,
  \emph{Predicting prognosis using molecular profiling in estrogen
  receptor-positive breast cancer treated with tamoxifen.}
  BMC Genomics, 9(1):239, 2008.}
\references{
  Loi et al.,
  \emph{Predicting prognosis using molecular profiling in estrogen
  receptor-positive breast cancer treated with tamoxifen.}
  BMC Genomics, 9(1):239, 2008.
}
\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}
\keyword{datasets}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./laplacianFromA.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{laplacianFromA}
\alias{laplacianFromA}


\title{Calculates the Laplacian associated to an adjacency matrix}

\description{
 Calculates the Laplacian associated to an adjacency matrix.
}

\usage{laplacianFromA(A, k=1, ltype=c("meanInfluence", "normalized", "unnormalized", "totalInfluence"))}

\arguments{
  \item{A}{The adjacency matrix of the graph.}
  \item{k}{...}
  \item{ltype}{A \code{\link[base]{character}} value specifying the type of Laplacian to be
    calculated.  Defaults to meanInfluence.}
}

\value{
 A \code{\link[base]{list}} containing the following components:
 \describe{
   \item{U}{Eigenvectors of the graph Laplacian.}
   \item{l}{Eigenvalues of the graph Laplacian}
   \item{kIdx}{Multiplicity of '0' as eigenvalue.}
  }
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\examples{
library("KEGGgraph")
library("rrcov")

## Create a random graph
graph <- randomWAMGraph(nnodes=5, nedges=7, verbose=TRUE)
plot(graph)

## Retrieve its adjacency matrix
A <- graph@adjMat

## write it to KGML file
grPathname <- "randomWAMGraph.xml"
writeAdjacencyMatrix2KGML(A, pathname=grPathname, verbose=TRUE, overwrite=TRUE)

## read it from file
gr <- parseKGML2Graph(grPathname)

## Two examples of Laplacians from the same graph
lapMI <- laplacianFromA(A, ltype="meanInfluence")
print(lapMI)

lapN <- laplacianFromA(A, ltype="normalized")
print(lapN)

U <- lapN$U
p <- nrow(A)
sigma <- diag(p)/sqrt(p)

X <- twoSampleFromGraph(100, 120, shiftM2=1, sigma, U=U, k=3)

## T2
t <- T2.test(X$X1,X$X2)
str(t)

tu <- graph.T2.test(X$X1, X$X2, lfA=lapMI, k=3)
str(tu)
}

\name{exprLoi2008}
\docType{data}
\alias{exprLoi2008}
\title{Gene expression data used in the DEGraph package vignette}
\description{
  This data set gives gene expression data for a subset of 227
  genes used in the DEGraph package vignette. This comes from the 15737
  gene, 255 patient dataset of Loi et al. (2008) which was used to study
  resistance to tamoxifen treatment in hormone-dependent breast cancer.
}
\usage{exprLoi2008}
\format{A matrix of 227 lines and 255 columns.}
\examples{
data("Loi2008_DEGraphVignette")

dim(exprLoi2008)
head(exprLoi2008)
}

\details{
  The original data set corresponds to data processed by RMA and median-centered
  as available from the GSE6532 GEO archive:
  http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE6532.
  
  These data were summarized from the probe set level to the gene level as 
  follows. The expression level of a gene was defined as the expression level 
  of the probe set with largest alignment score among all probe sets mapping 
  to this gene according to the annotation in GSE6532. When the largest 
  alignment score was achieved by several probe sets, the median expression 
  level of those probe sets was taken.
}

\source{
  Loi et al.,
  \emph{Predicting prognosis using molecular profiling in estrogen
  receptor-positive breast cancer treated with tamoxifen.}
  BMC Genomics, 9(1):239, 2008.}
\references{
  Loi et al.,
  \emph{Predicting prognosis using molecular profiling in estrogen
  receptor-positive breast cancer treated with tamoxifen.}
  BMC Genomics, 9(1):239, 2008.
}
\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}
\keyword{datasets}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./BS.test.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{BS.test}
\alias{BS.test}


\title{Performs the test of Bai and Saranadasa (1996)}

\description{
 Performs the test of Bai and Saranadasa (1996).
}

\usage{BS.test(X1, X2, na.rm=FALSE)}

\arguments{
  \item{X1}{A n1 x p \code{\link[base]{matrix}}, observed data for class 1: p variables, n1
    observations.}
  \item{X2}{A n2 x p \code{\link[base]{matrix}}, observed data for class 2: p variables, n2
    observations.}
  \item{na.rm}{A \code{\link[base]{logical}} value indicating whether variables with \code{\link[base]{NA}} in
    at least one of the n1 + n2 observations should be discarder before
    the test is performed.}
}

\value{
 A \code{\link[base]{list}} with class "htest" containing the following components:
 \describe{
   \item{statistic}{A \code{\link[base]{numeric}} value, the test statistic.}
   \item{p.value}{A \code{\link[base]{numeric}} value, the corresponding p-value.}
  }
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{
  \code{\link{AN.test}}()
  \code{\link{graph.T2.test}}()
  \code{\link{hyper.test}}()
}

\examples{
library("KEGGgraph")
## library("NCIgraph")
library("rrcov")

data("Loi2008_DEGraphVignette")
exprData <- exprLoi2008
classData <- classLoi2008
rn <- rownames(exprData)

## Retrieve expression levels data for genes from one KEGG pathway
gr <- grListKEGG[[1]]
gids <- translateKEGGID2GeneID(nodes(gr))
mm <- match(gids, rownames(exprData))

## Keep genes from the graph that are present in the expression data set
idxs <- which(!is.na(mm))
gr <- subGraph(nodes(gr)[idxs], gr)

idxs <- which(is.na(mm))
if(length(idxs)) {
  print("Gene ID not found in expression data: ")
  str(gids[idxs])
}
dat <- exprData[na.omit(mm), ]
str(dat)

X1 <- t(dat[, classData==0])
X2 <- t(dat[, classData==1])

## DEGraph T2 test
res <- testOneGraph(gr, exprData, classData, verbose=TRUE, prop=0.2)

## T2 test (Hotelling)
rT2 <- T2.test(X1, X2)
str(rT2)

## Adaptive Neyman test
rAN <- AN.test(X1, X2, na.rm=TRUE)
str(rAN)

## Adaptive Neyman test from Fan and Lin (1998)
rAN <- AN.test(X1, X2, na.rm=TRUE)
str(rAN)

## Test from Bai and Saranadasa (1996)
rBS <- BS.test(X1, X2, na.rm=TRUE)
str(rBS)

## Hypergeometric test
pValues <- apply(exprData, 1, FUN=function(x) {
  tt <- t.test(x[classData==0], x[classData==1])
  tt$p.value
})
str(pValues)
names(pValues) <- rownames(exprData)
rHyper <- hyper.test(pValues, gids, thr=0.01)
str(rHyper)

}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./graph.T2.test.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{graph.T2.test}
\alias{graph.T2.test}


\title{Performs the Hotelling T2 test in Fourier space}

\description{
 Performs the Hotelling T2 test in Fourier space.
}

\usage{graph.T2.test(X1, X2, G=NULL, lfA=NULL, ..., k=ncol(X1))}

\arguments{
  \item{X1}{A n1 x p \code{\link[base]{numeric}} \code{\link[base]{matrix}}, observed data for class 1: p variables, n1
    observations.}
  \item{X2}{A n2 x p \code{\link[base]{numeric}} \code{\link[base]{matrix}}, observed data for class 2: p variables, n2
    observations.}
  \item{G}{An object of class \code{\link[=graphAM-class]{graphAM}} or
    \code{\link[=graphNEL-class]{graphNEL}}, the graph to be used in the two-sample test.}
  \item{lfA}{A list returned by \code{\link{laplacianFromA}}(),
    containing the Laplacian eigen vectors and eigen values}
  \item{...}{Further arguments to be passed to \code{\link{laplacianFromA}}().}
  \item{k}{A \code{\link[base]{numeric}} value, number of Fourier components retained for the
    test.}
}

\value{
 A \code{\link[base]{list}} with class "htest", as returned by \code{\link{T2.test}}.
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{
  \code{\link{T2.test}}
  \code{\link[=graphAM-class]{graphAM}}
}

\examples{
library("rrcov")

## Some parameters
n1 <- n2 <- 20
nnodes <- nedges <- 20
k <- 3
ncp <- 0.5
sigma <- diag(nnodes)/sqrt(nnodes)


## Build graph, decompose laplacian
G <- randomWAMGraph(nnodes=nnodes,nedges=nedges)
A <- G@adjMat
lfA <- laplacianFromA(A,ltype="unnormalized")
U <- lfA$U
l <- lfA$l

## Build two samples with smooth mean shift
X <- twoSampleFromGraph(n1,n2,shiftM2=ncp,sigma,U=U,k=k)

## Do hypothesis testing
t <- T2.test(X$X1,X$X2) # Raw T-square
print(t$p.value)
tu <- graph.T2.test(X$X1,X$X2,lfA=lfA,k=k) # Filtered T-squares
print(tu$p.value)
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./getConnectedComponentList.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getConnectedComponentList}
\alias{getConnectedComponentList}


\title{Given a graph, returns a list of its connected components
(which are also graph objects), ordered by decreasing number of
nodes}

\description{
 Given a graph, returns a list of its connected components
(which are also graph objects), ordered by decreasing number of
nodes.
}

\usage{getConnectedComponentList(graph, verbose=FALSE)}

\arguments{
  \item{graph}{A \code{\link[=graph-class]{graph}} object.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{ A \code{\link[base]{list}} containing a \code{\link[=graph-class]{graph}} object for each connected
 component of the input graph, ordered by decreasing number of nodes
 }

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{\code{\link{connectedComp}}.}

\examples{
data("Loi2008_DEGraphVignette")
exprData <- exprLoi2008
rn <- rownames(exprData)

## Retrieve expression levels data for genes from one KEGG pathway
graph <- grListKEGG[[1]]
pname <- attr(graph, "label")
cat(verbose, "Pathway name: ", pname)

sgraph <- getSignedGraph(graph, verbose=TRUE)
print(sgraph)

graphList <- getConnectedComponentList(graph, verbose=TRUE)
print(graphList)

}

\name{grListKEGG}
\docType{data}
\alias{grListKEGG}
\title{KEGG networks used in the DEGraph package vignette}
\description{ This data set gives KEGGgraph objects for two KEGG
  non-metabolic pathways ("Natural killer cell mediated cytotoxicity"
  and "Insulin signaling pathway").}
\usage{grListKEGG}  
\format{A list of two elements.}
\examples{
library("Rgraphviz")

data("Loi2008_DEGraphVignette")

grListKEGG
plot(grListKEGG[[1]])
}
\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}
\keyword{datasets}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./twoSampleFromGraph.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{twoSampleFromGraph}
\alias{twoSampleFromGraph}


\title{Given a basis (typically the eigenvectors of a graph Laplacian), builds two multivariate normal samples with mean shift located in the first elements of the basis}

\description{
 Given a basis (typically the eigenvectors of a graph Laplacian), builds two multivariate normal samples with mean shift located in the first elements of the basis.
}

\usage{twoSampleFromGraph(n1=20, n2=n1, shiftM2=0, sigma, U, k=ceiling(ncol(U)/3))}

\arguments{
  \item{n1}{An \code{\link[base]{integer}} value specifying the number of points in the first sample.}
  \item{n2}{An \code{\link[base]{integer}} value specifying the number of points in the second sample.}
  \item{shiftM2}{A \code{\link[base]{numeric}} value giving the desired squared Mahalanobis norm of the mean shift between the two samples.}
  \item{sigma}{A matrix giving the covariance structure of each sample.}
  \item{U}{A matrix giving the desired basis.}
  \item{k}{An \code{\link[base]{integer}} value giving the number of basis elements in which the mean shift must be located.}
}

\value{ A \code{\link[base]{list}} with named elements:
 \describe{
   \item{X1}{The first sample in the original basis (before transformation by U).}
   \item{X2}{The second sample in the original basis (before transformation by U).}
   \item{X1}{The first sample in the specified basis (after transformation by U).}
   \item{X2}{The second sample in the specified basis (after transformation by U).}
   \item{mu1}{The population mean of F1}
   \item{mu2}{The population mean of F2}
   \item{diff}{mu1 - mu2}
  }
 }

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\examples{
library("KEGGgraph")
library("rrcov")

## Create a random graph
graph <- randomWAMGraph(nnodes=5, nedges=7, verbose=TRUE)
plot(graph)

## Retrieve its adjacency matrix
A <- graph@adjMat

## write it to KGML file
grPathname <- "randomWAMGraph.xml"
writeAdjacencyMatrix2KGML(A, pathname=grPathname, verbose=TRUE, overwrite=TRUE)

## read it from file
gr <- parseKGML2Graph(grPathname)

## Two examples of Laplacians from the same graph
lapMI <- laplacianFromA(A, ltype="meanInfluence")
print(lapMI)

lapN <- laplacianFromA(A, ltype="normalized")
print(lapN)

U <- lapN$U
p <- nrow(A)
sigma <- diag(p)/sqrt(p)

X <- twoSampleFromGraph(100, 120, shiftM2=1, sigma, U=U, k=3)

## T2
t <- T2.test(X$X1,X$X2)
str(t)

tu <- graph.T2.test(X$X1, X$X2, lfA=lapMI, k=3)
str(tu)
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./plotValuedGraph.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{plotValuedGraph}
\alias{plotValuedGraph}


\title{Plots a graph with nodes colored according to a quantitative variable}

\description{
 Plots a graph with nodes colored according to a quantitative variable.
}

\usage{plotValuedGraph(graph, values=NULL, nodeLabels=nodes(graph), qMax=0.95, colorPalette=heat.colors(10), adjustColorRange=FALSE, symmetrizeArrows=FALSE, height=1, lwd=1, cex=1, ..., verbose=FALSE)}

\arguments{
  \item{graph}{A \code{\link[=graph-class]{graph}} object.}
  \item{values}{A named \code{\link[base]{vector}} of \code{\link[base]{numeric}} values according to which the
    graph nodes should be colored.}
  \item{nodeLabels}{A \code{\link[base]{character}} \code{\link[base]{vector}} of the same length and in the
    same order as 'nodes(graph)': node labels to be displayed.  Defaults
    to 'nodes(graph)'.}
  \item{qMax}{A \code{\link[base]{numeric}} value, fraction of the data to be truncated in order
    to avoid outliers.}
  \item{colorPalette}{A \code{\link[base]{character}} vector, the set of colors to be used.}
  \item{adjustColorRange}{A \code{\link[base]{logical}} value.  If \code{\link[base:logical]{TRUE}}, the color range is
    adjusted to the range of values of nodes actually present in the graph.
    Defaults to \code{\link[base:logical]{FALSE}}, i.e. the color range spans range(values) regardless
    of which nodes are present in the graph.}
  \item{symmetrizeArrows}{A \code{\link[base]{logical}} value.  If \code{\link[base:logical]{TRUE}}, arrow tails are
    drawn as the corresponding arrow heads.  Defaults to \code{\link[base:logical]{FALSE}}.}
  \item{height}{A \code{\link[base]{numeric}} value, the (common) size of nodes.}
  \item{lwd}{A \code{\link[base]{numeric}} value, the (common) width of edges.}
  \item{cex}{A \code{\link[base]{numeric}} value, the relative size of the text for gene names.}
  \item{...}{Further arguments to be passed to 'edgeRenderInfo' and
    'nodeRenderInfo'.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
  A \code{\link[base]{list}} containing the following components:
  \describe{
    \item{graph}{The 'graph' object as plotted.}
    \item{breaks}{The break points in the supplied values (can be used for
      plotting a legend).}
  }
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{
  \code{\link{plotKEGGgraph}}
  \code{\link{plot}}()
}

\examples{
library("Rgraphviz")
library("KEGGgraph")
## library("NCIgraph")

data("Loi2008_DEGraphVignette")
exprData <- exprLoi2008
classData <- classLoi2008
annData <- annLoi2008

rn <- rownames(exprData)

## Retrieve expression levels data for genes from one KEGG pathway
graph <- grListKEGG[[1]]
pname <- attr(graph, "label")
print(pname)

## DEGraph T2 test
resList <- testOneGraph(graph, exprData, classData, verbose=TRUE, prop=0.2)

## Largest connected component
res <- resList[[1]]
gr <- res$graph

## individual t statistics
shift <- apply(exprData, 1, FUN=function(x) {
  tt <- t.test(x[classData==0], x[classData==1])
  tt$statistic
})
names(shift) <- translateGeneID2KEGGID(names(shift))

## color palette
if (require(marray)) {
  pal <- maPalette(low="red", high="green", mid="black", k=100)
} else {
  pal <- heat.colors(100)
}

## plot results
dn <- getDisplayName(gr, shortLabel=TRUE)
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
 
pvg <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, verbose=TRUE, cex=0.5)
title(pname)

txt1 <- sprintf("p(T2)=\%s", signif(res$p.value[1], 2))
txt2 <- sprintf("p(T2F[\%s])=\%s", res$k, signif(res$p.value[2]))
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
if (require(fields)) {
  image.plot(legend.only=TRUE, zlim=range(pvg$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3)
}
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./writeAdjacencyMatrix2KGML.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{writeAdjacencyMatrix2KGML}
\alias{writeAdjacencyMatrix2KGML}


\title{Writes an adjacency matrix into an XML file}

\description{
 Writes an adjacency matrix into an XML file.
}

\usage{writeAdjacencyMatrix2KGML(mat, pathname, nodePrefix="n", overwrite=FALSE, ..., verbose=FALSE)}

\arguments{
  \item{mat}{A \code{\link[base]{matrix}}, interpreted of the adjacency matrix of a graph.}
  \item{pathname}{The full path name of the XML file to be written.}
  \item{nodePrefix}{A \code{\link[base]{character}} value giving the prefix to which the node
    index in 'mat' will be appended.}
  \item{overwrite}{If \code{\link[base:logical]{TRUE}} and file already exists, overwrite it.}
  \item{...}{Further arguments to be passed to plotKEGGgraph.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
  None.
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{
  \code{\link{parseKGML2Graph}}
}

\examples{
library("KEGGgraph")
library("rrcov")

## Create a random graph
graph <- randomWAMGraph(nnodes=5, nedges=7, verbose=TRUE)
plot(graph)

## Retrieve its adjacency matrix
A <- graph@adjMat

## write it to KGML file
grPathname <- "randomWAMGraph.xml"
writeAdjacencyMatrix2KGML(A, pathname=grPathname, verbose=TRUE, overwrite=TRUE)

## read it from file
gr <- parseKGML2Graph(grPathname)

## Two examples of Laplacians from the same graph
lapMI <- laplacianFromA(A, ltype="meanInfluence")
print(lapMI)

lapN <- laplacianFromA(A, ltype="normalized")
print(lapN)

U <- lapN$U
p <- nrow(A)
sigma <- diag(p)/sqrt(p)

X <- twoSampleFromGraph(100, 120, shiftM2=1, sigma, U=U, k=3)

## T2
t <- T2.test(X$X1,X$X2)
str(t)

tu <- graph.T2.test(X$X1, X$X2, lfA=lapMI, k=3)
str(tu)
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./getSignedGraph.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getSignedGraph}
\alias{getSignedGraph}


\title{Given a graph, builds a signed version of the adjacency matrix
  taking into account the type of interaction (e.g., activation or
  inhibition)}

\description{
 Given a graph, builds a signed version of the adjacency matrix
  taking into account the type of interaction (e.g., activation or
  inhibition).
}

\usage{getSignedGraph(graph, positiveInteractionLabels=c("activation", "expression"), negativeInteractionLabels=c("inhibition", "repression"), verbose=FALSE)}

\arguments{
  \item{graph}{A \code{\link[=graph-class]{graph}} object.}
  \item{positiveInteractionLabels}{A \code{\link[base]{character}} \code{\link[base]{vector}} specifying which
    interaction labels correspond to positive interactions. Defaults to
    'c("activation", "expression")'.}
  \item{negativeInteractionLabels}{A \code{\link[base]{character}} \code{\link[base]{vector}} specifying which
    interaction labels correspond to negative interactions. Defaults to
    'c("inhibition", "repression")'.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
  This function returns a squared matrix whose (i,j) entry is:
  \describe{
    \item{0}{if edges i and j are not connected}
    \item{1}{if edges i and j are connected by a positive interaction}
    \item{-1}{if edges i and j are connected by a negative interaction.}
  }
  By construction, the absolute value of this matrix is the adjacency
  matrix of the graph. Edges which cannot interpreted as corresponding
  to a positive or a negative interaction are marked as not connected.
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\examples{
data("Loi2008_DEGraphVignette")
exprData <- exprLoi2008
rn <- rownames(exprData)

## Retrieve expression levels data for genes from one KEGG pathway
graph <- grListKEGG[[1]]
pname <- attr(graph, "label")
cat(verbose, "Pathway name: ", pname)

sgraph <- getSignedGraph(graph, verbose=TRUE)
print(sgraph)

graphList <- getConnectedComponentList(graph, verbose=TRUE)
print(graphList)

}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./testOneGraph.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{testOneGraph}
\alias{testOneGraph}


\title{Applies a serie of two-sample tests to each connected component
  of a graph using various statistics}

\description{
 Applies a serie of two-sample tests to each connected component
  of a graph using various statistics.
}

\usage{testOneGraph(graph, data, classes, useInteractionSigns=TRUE, ..., verbose=FALSE)}

\arguments{
  \item{graph}{A \code{\link[=graph-class]{graph}} object.}
  \item{data}{A 'matrix' (size: number 'p' of genes x number 'n' of samples) of gene expression.}
  \item{classes}{A 'vector' (length: 'n') of class assignments.}
  \item{useInteractionSigns}{A \code{\link[base]{logical}} value indicating whether the sign of interaction should be taken into account.}
  \item{...}{Further arguments to be passed to testOneConnectedComponent.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
 A structured \code{\link[base]{list}} containing the p-values of the tests, the
 \code{\link[=graph-class]{graph}} object of the connected component and the number of
 retained Fourier dimensions.
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{
  \code{\link{testOneConnectedComponent}}()
}

\examples{
library("Rgraphviz")
library("KEGGgraph")
## library("NCIgraph")

data("Loi2008_DEGraphVignette")
exprData <- exprLoi2008
classData <- classLoi2008
annData <- annLoi2008

rn <- rownames(exprData)

## Retrieve expression levels data for genes from one KEGG pathway
graph <- grListKEGG[[1]]
pname <- attr(graph, "label")
print(pname)

## DEGraph T2 test
resList <- testOneGraph(graph, exprData, classData, verbose=TRUE, prop=0.2)

## Largest connected component
res <- resList[[1]]
gr <- res$graph

## individual t statistics
shift <- apply(exprData, 1, FUN=function(x) {
  tt <- t.test(x[classData==0], x[classData==1])
  tt$statistic
})
names(shift) <- translateGeneID2KEGGID(names(shift))

## color palette
if (require(marray)) {
  pal <- maPalette(low="red", high="green", mid="black", k=100)
} else {
  pal <- heat.colors(100)
}

## plot results
dn <- getDisplayName(gr, shortLabel=TRUE)
mm <- match(translateKEGGID2GeneID(nodes(gr)), rownames(annData))
dn <- annData[mm, "NCBI.gene.symbol"]
 
pvg <- plotValuedGraph(gr, values=shift, nodeLabels=dn, qMax=0.95, colorPalette=pal, height=40, lwd=1, verbose=TRUE, cex=0.5)
title(pname)

txt1 <- sprintf("p(T2)=\%s", signif(res$p.value[1], 2))
txt2 <- sprintf("p(T2F[\%s])=\%s", res$k, signif(res$p.value[2]))
txt <- paste(txt1, txt2, sep="\n")
stext(side=3, pos=1, txt)
if (require(fields)) {
  image.plot(legend.only=TRUE, zlim=range(pvg$breaks), col=pal, legend.shrink=0.3, legend.width=0.8, legend.lab="t-scores", legend.mar=3.3)
}
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./getKEGGPathways.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getKEGGPathways}
\alias{getKEGGPathways}


\title{Builds a graph for each of the KEGG pathways}

\description{
 Builds a graph for each of the KEGG pathways.
}

\usage{getKEGGPathways(path=NULL, rootPath="networkData/ftp.genome.jp/pub/kegg/xml/kgml", organism="hsa", metaTag=c("non-metabolic", "metabolic"), pattern=NULL, verbose=FALSE)}

\arguments{
  \item{path}{A \code{\link[base]{character}} value, the local _full_ path of KGML data.}
  \item{rootPath}{A \code{\link[base]{character}} value, the local _root_ path of KGML data.}
  \item{organism}{A \code{\link[base]{character}} value specifying the organism whose
     pathways should be considered. Defaults to "hsa" (Homo Sapiens).}
  \item{metaTag}{A \code{\link[base]{character}} value, specifying the type of pathways to
    be considered ("metabolic" or "non-metabolic"). Defaults to "non-metabolic".}
  \item{pattern}{An optional \code{\link[base]{character}} value specifying a file name pattern to
    look for.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
  A \code{\link[base]{list}} containing a \code{\link[=graph-class]{graph}} object for each KEGG pathway with at least one edge.
}

\details{If 'path' is supplied, KGML files in this directory are loaded.
  Otherwise, KGML files are assumed to be in
  <rootPath>/<metaTag>/"organisms"/<organism>, which mirrors the
 structure of the KEGG KGML file repository.
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{
  \code{\link{parseKGML}}
  \code{\link{KEGGpathway2Graph}}
}

\examples{
library("Rgraphviz")
library("KEGGgraph")

## example of KGML files
path <- system.file("extdata", package="KEGGgraph")
grList <- getKEGGPathways(path=path, verbose=TRUE)
print(grList)

graph <- grList[[1]]
plotKEGGgraph(graph)

\dontrun{
  ## Download all human KGML pathways locally
  pathname <- system.file("downloadScripts", "downloadKeggXmlFiles.R", package="DEGraph")
  source(pathname)

  ## Load some of them
  grList <- getKEGGPathways(pattern="040", verbose=TRUE)
  print(grList)

  graph <- grList[[1]]
  plotKEGGgraph(graph)
}
}

\name{classLoi2008}
\docType{data}
\alias{classLoi2008}
\title{Tamoxifen treatment resistance status data used in the DEGraph
  package vignette}

\description{ This data set gives resistance status data for the 255
  patients used in the DEGraph package vignette. This comes from the
  15737 gene, 255 patient dataset of Loi et al. (2008) which was used to
  study resistance to tamoxifen treatment in hormone-dependent breast
  cancer.  }
\usage{classLoi2008}
\format{A vector of 255 elements which are either 0 (resistance to
  treatment) or 1 (sensitivity to treatment).}
\examples{
data("Loi2008_DEGraphVignette")

dim(classLoi2008)
head(classLoi2008)
}
\source{
  Loi et al.,
  \emph{Predicting prognosis using molecular profiling in estrogen
  receptor-positive breast cancer treated with tamoxifen.}
BMC Genomics, 9(1):239, 2008.}
\references{
  Loi et al.,
  \emph{Predicting prognosis using molecular profiling in estrogen
  receptor-positive breast cancer treated with tamoxifen.}
  BMC Genomics, 9(1):239, 2008.
}
\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}
\keyword{datasets}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./testOneConnectedComponent.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{testOneConnectedComponent}
\alias{testOneConnectedComponent}


\title{Applies a series of two-sample tests to a connected graph using various statistics}

\description{
 Applies a series of two-sample tests to a connected graph using various statistics.
}

\usage{testOneConnectedComponent(graph, data, classes, ..., prop=0.2, verbose=FALSE)}

\arguments{
  \item{graph}{A \code{\link[=graph-class]{graph}} object.}
  \item{data}{A '\code{\link[base]{numeric}} \code{\link[base]{matrix}} (size: number 'p' of genes x number 'n' of samples) of gene expression.}
  \item{classes}{A \code{\link[base]{character}} \code{\link[base]{vector}} (length: 'n') of class assignments.}
  \item{...}{Further arguments to be passed to \code{\link{laplacianFromA}}().}
  \item{prop}{A \code{\link[base]{numeric}} value, percentage of components retained for Fourier and PCA.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
 A structured \code{\link[base]{list}} containing the p-values of the tests, the
 \code{\link[=graph-class]{graph}} object of the connected component and the number
 of retained Fourier dimensions.
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\details{
  This function performs the test, assuming that all genes
  in the graph are represented in the expression data set,
  in order not to have to modify the graph topology.

  Interaction signs are used if available in the graph
  ('getSignedGraph' is not called here, in order not to
  have to modify the graph topology.).

  The graph given as input has to have only one
  connex component.  It can be retrieved from the output of
  \code{\link{getConnectedComponentList}}().
}

\seealso{
  \code{\link{testOneGraph}}()
  \code{\link{getConnectedComponentList}}()
}

\examples{
library("rrcov")

## Some parameters
n1 <- n2 <- 20
nnodes <- nedges <- 20
k <- 3
ncp <- 0.5
sigma <- diag(nnodes)/sqrt(nnodes)


## Build graph, decompose laplacian
G <- randomWAMGraph(nnodes=nnodes,nedges=nedges)
A <- G@adjMat
lfA <- laplacianFromA(A,ltype="unnormalized")
U <- lfA$U
l <- lfA$l

## Build two samples with smooth mean shift
X <- twoSampleFromGraph(n1,n2,shiftM2=ncp,sigma,U=U,k=k)

## Do hypothesis testing
t <- T2.test(X$X1,X$X2) # Raw T-square
print(t$p.value)
tu <- graph.T2.test(X$X1,X$X2,lfA=lfA,k=k) # Filtered T-squares
print(tu$p.value)
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  ./randomWAMGraph.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{randomWAMGraph}
\alias{randomWAMGraph}


\title{Generates a random graph}

\description{
 Generates a random graph.
}

\usage{randomWAMGraph(nnodes=5, nedges=nnodes, verbose=FALSE)}

\arguments{
  \item{nnodes}{A \code{\link[base]{numeric}} value, the desired number of nodes.}
  \item{nedges}{A \code{\link[base]{numeric}} value, the desired number of edges.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
 An object of class \code{\link[=graphAM-class]{graphAM}}.
}

\author{Laurent Jacob, Pierre Neuvial and Sandrine Dudoit}

\seealso{
  \code{\link[=graphAM-class]{graphAM}}.
}

\examples{
library("KEGGgraph")
library("rrcov")

## Create a random graph
graph <- randomWAMGraph(nnodes=5, nedges=7, verbose=TRUE)
plot(graph)

## Retrieve its adjacency matrix
A <- graph@adjMat

## write it to KGML file
grPathname <- "randomWAMGraph.xml"
writeAdjacencyMatrix2KGML(A, pathname=grPathname, verbose=TRUE, overwrite=TRUE)

## read it from file
gr <- parseKGML2Graph(grPathname)

## Two examples of Laplacians from the same graph
lapMI <- laplacianFromA(A, ltype="meanInfluence")
print(lapMI)

lapN <- laplacianFromA(A, ltype="normalized")
print(lapN)

U <- lapN$U
p <- nrow(A)
sigma <- diag(p)/sqrt(p)

X <- twoSampleFromGraph(100, 120, shiftM2=1, sigma, U=U, k=3)

## T2
t <- T2.test(X$X1,X$X2)
str(t)

tu <- graph.T2.test(X$X1, X$X2, lfA=lapMI, k=3)
str(tu)
}
